package com.clcbio.api.clc.workflows.bean;

import java.io.Serializable;


/**
 * Bean representation of a com.clcbio.api.clc.workflows.Workflow for serialization
 * 
 * @author joecker
 * 
 */
public class WorkflowHandlerBean implements Serializable {
    private static final long serialVersionUID = 9064064858508804525L;
    private String type;
    private String id;
    private String name;
    private String description;
    
    public WorkflowHandlerBean() {
        super();
        type = "";
        id = "";
    }
    
    public WorkflowHandlerBean(WorkflowHandlerBean cloneSource) {
        type = cloneSource.getType();
        id = cloneSource.getId();
    }
    
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setId(String id) {
        this.id = id;
    }
    
    public void setType(String type) {
        this.type = type;
    }
    
    public String getId() {
        return id;
    }
    
    public String getType() {
        return type;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((description == null) ? 0 : description.hashCode());
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((type == null) ? 0 : type.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        WorkflowHandlerBean other = (WorkflowHandlerBean) obj;
        if (description == null) {
            if (other.description != null)
                return false;
        }
        else if (!description.equals(other.description))
            return false;
        if (id == null) {
            if (other.id != null)
                return false;
        }
        else if (!id.equals(other.id))
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        }
        else if (!name.equals(other.name))
            return false;
        if (type == null) {
            if (other.type != null)
                return false;
        }
        else if (!type.equals(other.type))
            return false;
        return true;
    }
    
    @Override
    public String toString() {
        return "WorkflowHandlerBean [type=" + type + ", id=" + id + ", name=" + name + ", description=" + description + "]";
    }
}
