package com.clcbio.client.thin.api;

import java.util.List;

import com.clcbio.client.thin.model.CLCObjectPath;
import com.clcbio.client.thin.model.CLCObjectReference;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.constrain.ClcObjectTypeConstraints;
import com.clcbio.client.thin.model.editor.elementinfo.EditableCLCObject;
import com.clcbio.client.thin.model.importexport.ExportPluginReference;
import com.clcbio.client.thin.model.importexport.ImportPluginReference;
import com.clcbio.client.thin.model.legacy.CLCObjectReferences;
import com.clcbio.client.thin.model.tree.CLCTreeItem;
import com.clcbio.client.thin.model.viewer.ClcObjectThin;
import com.google.gwt.user.client.rpc.AsyncCallback;

// The async pendents according to the GWT contract
public interface CLCServerApiDataAsync extends SerializableGWTTypesAsync {
    public void query(String query, String sessionID, AsyncCallback callback);

    public void getTreeItem(List<ClcUrlParameter> clcUrls, String sessionID, AsyncCallback<List<CLCTreeItem>> callback);

    public void getTreeItems(CLCObjectReference objectReference, ClcObjectTypeConstraints constraints, String sessionID, AsyncCallback<CLCTreeItem> callback);

    public void getTreeItemPath(ClcUrlParameter objectReference, String sessionID, AsyncCallback<CLCObjectPath> callback);

    public void getImportPluginReferences(String sessionID, AsyncCallback<ImportPluginReference[]> callback);

    public void getExportPluginReferences(String sessionID, AsyncCallback<ExportPluginReference[]> callback);

    public void getExportPluginReferencesSuitable(List<CLCObjectReference> clcObjectReferences, String sessionID,
            AsyncCallback callback);

    public void getClcObjectThin(CLCObjectReference objectReference, String sessionID, AsyncCallback<ClcObjectThin> callback);

    public void updateObject(EditableCLCObject updatedObject, String sessionID, AsyncCallback callback);

    public void createContainerBefore(String containerName, CLCObjectReference persistenceContainerInto,
            CLCObjectReference persistenceStructureBefore, String sessionID, AsyncCallback callback);

    public void removeContainers(CLCObjectReferences persistenceStructures, String sessionID, AsyncCallback callback);

    public void emptyRecycleBin(String persistenceModelId, String sessionId, AsyncCallback callback);

    public void getPermissions(String pmId, String containerId, String sessionId, AsyncCallback callback);

    public void setPermissions(String pmId, String containerId, String groupId, boolean canRead, boolean canWrite, boolean recurse,
            String sessionId, AsyncCallback callback);

    public void getGroups(String userId, String sessionId, AsyncCallback callback);

    public void getAllGroups(String sessionId, AsyncCallback<List<String>> callback);

    public void getUsersInGroup(String groupId, String sessionId, AsyncCallback callback);

    public void getUsers(String session, AsyncCallback callback);

    public void getServerInformation(AsyncCallback callback);

}
