package com.clcbio.client.thin.api;

import java.util.List;

import com.clcbio.client.thin.model.ClcUrlParsed;
import com.clcbio.client.thin.model.CloneTransport;
import com.clcbio.client.thin.model.ThinBinaryData;
import com.clcbio.client.thin.model.admin.ThinPluginDescriptor;
import com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand.InstalledTemplateCommand;
import com.clcbio.client.thin.model.admin.configuration.subsystem.workflow.InstalledWorkflowPlugin;
import com.clcbio.client.thin.model.admin.workflow.InstalledWorkflows;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.ServerCommandOutput;
import com.clcbio.client.thin.model.command.ServerCommandReference;
import com.clcbio.client.thin.model.exceptions.ServiceException;
import com.clcbio.client.thin.model.executionenvironment.ServerExecutionEnvironment;
import com.clcbio.client.thin.model.processes.ClcProcessReflection;
import com.clcbio.client.thin.model.processes.UserProcesses;
import com.clcbio.client.thin.model.qualification.QualificationReport;
import com.clcbio.client.thin.model.qualification.QualificationReportWorkflow;
import com.clcbio.client.thin.model.schedule.Interval;
import com.clcbio.client.thin.model.schedule.ScheduledCommand;
import com.google.gwt.user.client.rpc.AsyncCallback;

public interface CLCServerApiProcessAsync extends SerializableGWTTypesAsync {

    public void getServerCommandRefsLoaded(String sessionID, AsyncCallback<ServerCommandReference[]> callback);

    public void getServerCommandRefLoaded(String sessionID, String serverCommandId, AsyncCallback<ServerCommandReference> callback);

    public void getServerCommandRefsRegistered(String sessionID, AsyncCallback callback);

    public void queueExecute(String sessionID, ServerCommandReference commandReference, AsyncCallback<String> callback);

    public void schedule(String sessionID, ServerCommandReference commandReference, List<Interval> intervals, AsyncCallback callback);

    public void getSessionProcess(String sessionID, String processID, AsyncCallback<ClcProcessReflection> callback);

    public void getSessionProcesses(String sessionID, AsyncCallback<UserProcesses> callback);

    public void doStopProcess(String sessionID, String processID, AsyncCallback callback);

    public void doSuspendProcess(String sessionID, String processID, AsyncCallback callback);

    public void doResumeProcess(String sessionID, String processID, AsyncCallback callback);

    public void doAbort(String sessionID, String processID, AsyncCallback callback);

    public void getProcessOutputType(String sessionID, String processID, AsyncCallback callback);

    public void getProcessOutput(String sessionID, String processID, AsyncCallback<ServerCommandOutput> callback);

    public void doRemoveTerminatedProcess(String sessionID, String processID, AsyncCallback<Void> callback);

    public void doStopRequeueProcess(String sessionID, String processID, AsyncCallback callback);

    public void deleteScheduledCommand(String sessionID, String scheduleId, AsyncCallback callback);

    public void getScheduledCommands(String sessionID, AsyncCallback callback);

    public void updateScheduledCommand(String sessionID, ScheduledCommand scheduledCommand, AsyncCallback callback);

    public void parseClcUrl(String sessionID, ClcUrlParameter clcUrlParameter, AsyncCallback<ClcUrlParsed> callback);
    
    public void getExecutionEnvironments(String sessionID, AsyncCallback<List<ServerExecutionEnvironment>> callback);
   
    public void workflowManagerList(String sessionID, AsyncCallback<InstalledWorkflows> callback);
    
    public void workflowManagerInstall(String sessionID, InstalledWorkflowPlugin newWorkflow, AsyncCallback<QualificationReportWorkflow> callback);
    
    public void workflowManagerUnInstall(String sessionID, String installedWorkflowPluginId, AsyncCallback<Void> callback);
    
    public void workflowManagerUpdate(String sessionID, String pluginToUpdateId, InstalledTemplateCommand updatedCommand, AsyncCallback<QualificationReportWorkflow> callback);

    public void qualify(String sessionID, ServerCommandReference executionCandidate, AsyncCallback<QualificationReport> callback);
    
    public void remoteClone(String sessionID, CloneTransport cloneTransport, AsyncCallback<CloneTransport> callback);

}
