package com.clcbio.client.thin.interpretation;

import com.clcbio.api.clc.workflows.bean.WorkflowRole;
import com.clcbio.client.thin.model.qualification.QualificationClassification;
import com.clcbio.client.thin.model.qualification.WorkflowRoleCommons;

public class QualificationInterpreter {
    
    public static boolean hasEditableParams(WorkflowRoleCommons roleCommons, WorkflowRole currentRole){
        return roleCommons.getHighestCommonDenominatorParameters().ordinal() >= currentRole.ordinal();
    }
    public static boolean parametersAreValidForRole(WorkflowRoleCommons roleCommons, WorkflowRole currentRole){
        WorkflowRole invalid = roleCommons.getLowestCommonDenominatorInvalidParameters();
        WorkflowRole inconsistent = roleCommons.getLowestCommonDenominatorInconsistentParameters();
        WorkflowRole missing = roleCommons.getLowestCommonDenominatorMissingParameters();
        return invalid.equals(WorkflowRole.NONE) && inconsistent.equals(WorkflowRole.NONE) && missing.ordinal() > currentRole.ordinal();
    }
    
    public static boolean refersToInstalledCommand(QualificationClassification commandQualification){
        int reportOrdinal = commandQualification.ordinal();
        int installBaseOKOrdinal = QualificationClassification.LEVEL_02_QUALIFIES_COMMANDS.ordinal();
        return reportOrdinal >= installBaseOKOrdinal;
    }
    public static boolean parameterRoleVisibleTo(WorkflowRole currentRole) {
        return currentRole.ordinal() < WorkflowRole.ENDUSER.ordinal();
    }
}
