package com.clcbio.client.thin.model;

import java.util.HashMap;

import com.google.gwt.user.client.rpc.IsSerializable;

public class CLCClientSession implements IsSerializable {
    private String sessionId;
    private int userSessionTimeOutSeconds;
    private long creationTimeMiliSeconds;
    private String username;
    private String userEmail;
    private boolean isAdmin;
    private HashMap<String, String> sessionContext;
    private String clientIpAddress;
    private boolean isGwtContext;
    private String clientHost;
    private String serverName;
    private int serverPort;

    public String getUserEmail() {
        return userEmail;
    }

    public void setUserEmail(String userEmail) {
        this.userEmail = userEmail;
    }

    public long getCreationTimeMiliSeconds() {
        return creationTimeMiliSeconds;
    }

    public void setCreationTimeMiliSeconds(long creationTimeMiliSeconds) {
        this.creationTimeMiliSeconds = creationTimeMiliSeconds;
    }

    public String getSessionId() {
        return sessionId;
    }

    public void setSessionId(String sessionId) {
        this.sessionId = sessionId;
    }

    public int getUserSessionTimeOutSeconds() {
        return userSessionTimeOutSeconds;
    }

    public void setUserSessionTimeOutSeconds(int userSessionTimeOutSeconds) {
        this.userSessionTimeOutSeconds = userSessionTimeOutSeconds;
    }

    /**
     * @return the username
     */
    public String getUsername() {
        return username;
    }

    /**
     * @param username
     *            the username to set
     */
    public void setUsername(String username) {
        this.username = username;
    }

    public HashMap<String, String> getSessionContext() {
        return sessionContext;
    }

    public void setSessionContext(HashMap<String, String> sessionContext) {
        this.sessionContext = sessionContext;
    }

    public String getClientIpAddress() {
        return clientIpAddress;
    }

    public void setClientIpAddress(String loggedInIpAddress) {
        this.clientIpAddress = loggedInIpAddress;
    }

    public boolean isGwtContext() {
        return isGwtContext;
    }

    public void setGwtContext(boolean isGwtContext) {
        this.isGwtContext = isGwtContext;
    }

    public String getClientHost() {
        return clientHost;
    }

    public void setClientHost(String loggedInHost) {
        this.clientHost = loggedInHost;
    }

    public boolean isAdmin() {
        return isAdmin;
    }

    public void setAdmin(boolean isAdmin) {
        this.isAdmin = isAdmin;
    }

    public String getServerName() {
        return serverName;
    }

    public void setServerName(String serverName) {
        this.serverName = serverName;
    }

    public int getServerPort() {
        return serverPort;
    }

    public void setServerPort(int serverPort) {
        this.serverPort = serverPort;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (creationTimeMiliSeconds ^ (creationTimeMiliSeconds >>> 32));
        result = prime * result + (isAdmin ? 1231 : 1237);
        result = prime * result + (isGwtContext ? 1231 : 1237);
        result = prime * result + ((clientHost == null) ? 0 : clientHost.hashCode());
        result = prime * result + ((clientIpAddress == null) ? 0 : clientIpAddress.hashCode());
        result = prime * result + ((serverName == null) ? 0 : serverName.hashCode());
        result = prime * result + serverPort;
        result = prime * result + ((sessionContext == null) ? 0 : sessionContext.hashCode());
        result = prime * result + ((sessionId == null) ? 0 : sessionId.hashCode());
        result = prime * result + ((userEmail == null) ? 0 : userEmail.hashCode());
        result = prime * result + userSessionTimeOutSeconds;
        result = prime * result + ((username == null) ? 0 : username.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        CLCClientSession other = (CLCClientSession) obj;
        if (creationTimeMiliSeconds != other.creationTimeMiliSeconds)
            return false;
        if (isAdmin != other.isAdmin)
            return false;
        if (isGwtContext != other.isGwtContext)
            return false;
        if (clientHost == null) {
            if (other.clientHost != null)
                return false;
        }
        else if (!clientHost.equals(other.clientHost))
            return false;
        if (clientIpAddress == null) {
            if (other.clientIpAddress != null)
                return false;
        }
        else if (!clientIpAddress.equals(other.clientIpAddress))
            return false;
        if (serverName == null) {
            if (other.serverName != null)
                return false;
        }
        else if (!serverName.equals(other.serverName))
            return false;
        if (serverPort != other.serverPort)
            return false;
        if (sessionContext == null) {
            if (other.sessionContext != null)
                return false;
        }
        else if (!sessionContext.equals(other.sessionContext))
            return false;
        if (sessionId == null) {
            if (other.sessionId != null)
                return false;
        }
        else if (!sessionId.equals(other.sessionId))
            return false;
        if (userEmail == null) {
            if (other.userEmail != null)
                return false;
        }
        else if (!userEmail.equals(other.userEmail))
            return false;
        if (userSessionTimeOutSeconds != other.userSessionTimeOutSeconds)
            return false;
        if (username == null) {
            if (other.username != null)
                return false;
        }
        else if (!username.equals(other.username))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "CLCClientSession [sessionId=" + sessionId + ", userSessionTimeOutSeconds=" + userSessionTimeOutSeconds
                + ", creationTimeMiliSeconds=" + creationTimeMiliSeconds + ", username=" + username + ", userEmail=" + userEmail
                + ", isAdmin=" + isAdmin + ", sessionContext=" + sessionContext + ", loggedInIpAddress=" + clientIpAddress
                + ", isGwtContext=" + isGwtContext + ", loggedInHost=" + clientHost + ", serverName=" + serverName + ", serverPort="
                + serverPort + "]";
    }

}
