package com.clcbio.client.thin.model;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * A thin client reference to a corresponding Model Object
 * 
 */
public class CLCObjectReference implements IsSerializable {
    private String persistenceModelId;
    private String clcObjectId;
    private String objectName;
    private String DELIMITER = "com.clcbio.client.thin.model.CLCObjectReference";

    public CLCObjectReference() {
        super();
    }

    public CLCObjectReference(CLCObjectReference cloneFrom) {
        super();
        persistenceModelId = cloneFrom.getPersistenceModelId();
        clcObjectId = cloneFrom.getClcObjectId();
        objectName = cloneFrom.getObjectName();
    }

    public CLCObjectReference(String persistenceModelId, String clcObjectId) {
        super();
        this.persistenceModelId = persistenceModelId;
        this.clcObjectId = clcObjectId;
    }

    public CLCObjectReference(String persistenceModelId, String clcObjectId, String objectName) {
        super();
        this.persistenceModelId = persistenceModelId;
        this.clcObjectId = clcObjectId;
        this.objectName = objectName;
    }

    public String getPersistenceModelId() {
        return persistenceModelId;
    }

    public void setPersistenceModelId(String persistenceModelId) {
        this.persistenceModelId = persistenceModelId;
    }

    public String getClcObjectId() {
        return clcObjectId;
    }

    public void setClcObjectId(String clcObjectId) {
        this.clcObjectId = clcObjectId;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof CLCObjectReference) {
            String clcObjectId2 = ((CLCObjectReference) obj).getClcObjectId();
            if(clcObjectId2 == null){
                return getClcObjectId() == null;
            }
            else{
                return clcObjectId2.equals(getClcObjectId());
            }
        }
        else {
            return false;
        }
    }

    @Override
    public String toString() {
        return getPersistenceModelId() + DELIMITER + getClcObjectId();
    }

    public CLCObjectReference(String fromString) {
        super();
        if (fromString != null) {
            String[] args = fromString.split(DELIMITER);
            if (args.length == 2) {
                setPersistenceModelId(args[0]);
                setClcObjectId(args[1]);
            }
        }
    }

    public String getObjectName() {
        return objectName;
    }

    public void setObjectName(String objectName) {
        this.objectName = objectName;
    }

    /*
     * Would have used clone, but this is not allowed in GWT serialized objects
     */
    public CLCObjectReference clone4log() {
        CLCObjectReference clone = new CLCObjectReference(persistenceModelId, clcObjectId);
        clone.setObjectName(getObjectName());
        return clone;
    }

}
