package com.clcbio.client.thin.model;

import java.io.Serializable;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 *Lowest common denominator for various Java Bean Serialization Mechanisms
 *GWT/JSON/JAX_B/JAX_WS/JSR57
 *
 * Consider that:
 *
 * null is not transferred as value (JAX_B)
 * no final fields or methods allowed (GWT)
 * no interfaces/abstract classes allowed (JAX_B)
 * no fields of type Object allowed (GWT) (collections of Object is ok...)
 * no Classes allowed (GWT)
 * no javadoc linkage {@link } to non serializable types (GWT)
 * Double.doubleToLongBits() not supported (GWT)
 *
 */
public interface CommonBeanSerialization extends IsSerializable, Serializable {

}
