package com.clcbio.client.thin.model;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.api.clc.workflows.bean.WorkflowBean;
import com.clcbio.api.clc.workflows.bean.WorkflowConnectionBean;
import com.clcbio.api.clc.workflows.bean.WorkflowElementBean;
import com.clcbio.api.clc.workflows.bean.WorkflowElementBeanParameter;
import com.clcbio.api.clc.workflows.bean.WorkflowHandlerBean;
import com.clcbio.client.thin.model.admin.ThinPluginDescripterBinaryIcon;
import com.clcbio.client.thin.model.admin.configuration.ServerConfigurationModule;
import com.clcbio.client.thin.model.admin.configuration.subsystem.authentication.AuthenticationConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.authentication.Group;
import com.clcbio.client.thin.model.admin.configuration.subsystem.cluster.Node;
import com.clcbio.client.thin.model.admin.configuration.subsystem.cluster.SlaveNodeManagerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.directcommand.DirectCommandConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.grid.GridConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.permission.ServerApiPermissionConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.safefiles.SafeFileDirectories;
import com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand.InstalledTemplateCommand;
import com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand.TemplateCommandManagerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.users.UserConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.workflow.InstalledWorkflowPlugin;
import com.clcbio.client.thin.model.admin.configuration.subsystem.workflow.WorkflowConfiguration;
import com.clcbio.client.thin.model.admin.configuration.system.ServerMainConfiguration;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.ServerCommandReference;
import com.clcbio.client.thin.model.command.algo.ServerCommandAlgoOutput;
import com.clcbio.client.thin.model.command.algo.ServerCommandAlgoParameters;
import com.clcbio.client.thin.model.command.algo.ServerCommandAlgoReference;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeBoolean;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeByte;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrl;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrlFile;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrlObject;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeDouble;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeInteger;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeLong;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeString;
import com.clcbio.client.thin.model.command.batch.ServerBatchCommandParameters;
import com.clcbio.client.thin.model.command.clexe.master.CommandLineExecuterMasterOutput;
import com.clcbio.client.thin.model.command.clexe.master.CommandLineExecuterMasterParameters;
import com.clcbio.client.thin.model.command.clexe.master.CommandLineExecuterMasterReference;
import com.clcbio.client.thin.model.command.clexe.types.TypeContextSubstitute;
import com.clcbio.client.thin.model.command.clexe.types.TypeInteger;
import com.clcbio.client.thin.model.command.clexe.types.TypeSafeFile;
import com.clcbio.client.thin.model.command.direct.DirectCommandOutput;
import com.clcbio.client.thin.model.command.direct.DirectCommandParameters;
import com.clcbio.client.thin.model.command.direct.DirectCommandReference;
import com.clcbio.client.thin.model.command.grid.GridExecuterCommandReference;
import com.clcbio.client.thin.model.command.grid.GridExecuterParameters;
import com.clcbio.client.thin.model.command.maintenance.RemoveTerminatedProcessesCommandReference;
import com.clcbio.client.thin.model.command.maintenance.RemoveTerminatedProcessesOutput;
import com.clcbio.client.thin.model.command.maintenance.RemoveTerminatedProcessesParameters;
import com.clcbio.client.thin.model.command.plugin.ServerPluginManagementCommandReference;
import com.clcbio.client.thin.model.command.plugin.ServerPluginManagementParameters;
import com.clcbio.client.thin.model.command.workflow.WorkflowCommandOutput;
import com.clcbio.client.thin.model.command.workflow.WorkflowCommandParameters;
import com.clcbio.client.thin.model.command.workflow.parameter.WorkflowElementBeanParameterExternal;
import com.clcbio.client.thin.model.command.workflow.parameter.WorkflowElementBeanParameterExternalOrphane;
import com.clcbio.client.thin.model.executionenvironment.ServerCLCExecutionEnvironment;
import com.clcbio.client.thin.model.executionenvironment.ServerGridExecutionEnvironment;
import com.clcbio.client.thin.model.legacy.CLCObjectReferences;
import com.clcbio.client.thin.model.log.DataBaseType;
import com.clcbio.client.thin.model.safefile.SafeFileLocation;
import com.clcbio.client.thin.model.safefile.SafeFileLocations;
import com.clcbio.client.thin.model.serialization.SerializedBeanJSON;

/**
 * This is the GWT pendant for the "@XmlSeeAlso" of JAX-B. It is not necessary
 * equal to the XmlSeeAlso's in our SOAP interface, since JAX-B has other rules
 * for serialization and object hierarchy traversal. Furthermore we might also
 * have different opinions about which object should go where.
 */
public class GwtWhitelist implements CommonBeanSerialization {
    private static final long serialVersionUID = -4273266508445903174L;
    public InstalledTemplateCommand templateCommand;
    public ServerCommandReference commandReference;
    public ServerCommandAlgoParameters serverCommandAlgoParameters;
    public ServerCommandAlgoOutput serverCommandAlgoOutput;
    public RemoveTerminatedProcessesCommandReference removeTerminatedProcessesCommandReference;
    public RemoveTerminatedProcessesParameters removeTerminatedProcessesParameters;
    public RemoveTerminatedProcessesOutput removeTerminatedProcessesOutput;
    public ArrayList arrayList;
    public List aList;
    public CLCObjectReferences refs;
    public DataBaseType dataBaseType;
    public SlaveNodeManagerConfiguration slaveNodeManagerConfiguration;
    public ServerMainConfiguration serverMainConfiguration;
    public Node slaveNode;
    public ServerPluginManagementCommandReference serverPluginManagementCommandReference;
    public ServerPluginManagementParameters serverPluginManagementParameters;
    public ServerConfigurationModule serverConfigurationModule;
    public TemplateCommandManagerConfiguration templateCommandManagerConfiguration;
    public CommandLineExecuterMasterParameters commandLineExecuterMasterParameters;
    public AuthenticationConfiguration authenticationConfiguration;
    public UserConfiguration userConfiguration;
    public Group group;
    public CommandLineExecuterMasterOutput masterOutput;
    public ServerInformation serverInformation;
    public CommandLineExecuterMasterReference commandLineExecuterMasterReference;
    public SafeFileDirectories safeFileDirectories;
    public SafeFileLocation safeFileLocation;
    public SafeFileLocations safeFileLocations;
    public GridExecuterCommandReference gridExecuterCommandReference;
    public GridExecuterParameters gridExecuterParameters;
    public GridConfiguration gridConfiguration;
    public ServerBatchCommandParameters batchCommandParameters;
    public ClcUrlParameter clcUrlParameter;
    public ServerCLCExecutionEnvironment serverCLCExecutionEnvironment;
    public ServerGridExecutionEnvironment serverGridExecutionEnvironment;
    public ServerApiPermissionConfiguration apiPermissionConfiguration;
    public DirectCommandReference reference;
    public DirectCommandOutput dco;
    public DirectCommandParameters dcp;
    public SerializedBeanJSON tpjson;
    public DirectCommandConfiguration directCommandConfiguration;
    public TypeContextSubstitute contextSubstitute;
    public WorkflowCommandParameters workflowp;
    public WorkflowConfiguration wfConfiguration;
    public InstalledWorkflowPlugin plugin;
    public ServerCommandAlgoReference algoReference;
    public ThinPluginDescripterBinaryIcon tpdbi;
    public WorkflowBean wfb;
    public WorkflowConnectionBean wcb;
    public WorkflowElementBean web;
    public WorkflowHandlerBean whb;
    public WorkflowElementBeanParameter awebp;
    public WorkflowElementBeanParameterExternal workflowElementBeanParameter;
    public ValueTypeBoolean q2;
    public ValueTypeByte r2;
    public ValueTypeClcUrl s2;
    public ValueTypeClcUrlFile t2;
    public ValueTypeClcUrlObject u2;
    public ValueTypeDouble v2;
    public ValueTypeInteger w2;
    public ValueTypeLong x2;
    public ValueTypeString y2;
    public WorkflowElementBeanParameterExternalOrphane z2;
    public TypeInteger a3;
    public WorkflowCommandOutput b3;
    public TypeSafeFile c3;
}
