package com.clcbio.client.thin.model;

import com.google.gwt.user.client.rpc.IsSerializable;

public class ServerInformation implements IsSerializable {
    private String productId;
    private String productName;
    private long version;
    private long serverFacadeVersion;

    private boolean validLicense;
    private boolean databaseEnabled;
    private boolean limitedMode;
    private boolean cloudMode;

    private int jobNodes = 0;

    private boolean debugMode;

    public ServerInformation() {
        productId = "";
        productName = "";
        version = -1;
        validLicense = false;
        limitedMode = false;
        databaseEnabled = false;
        debugMode = false;
        cloudMode = false;
    }

    public ServerInformation(String productId, String productName, long version, long serverFacadeVersion, boolean validLicense,
            boolean limitedMode, boolean databaseEnabled, int jobNodes, boolean debugMode, boolean cloudMode) {
        super();
        this.productId = productId;
        this.productName = productName;
        this.version = version;
        this.serverFacadeVersion = serverFacadeVersion;
        this.validLicense = validLicense;
        this.limitedMode = limitedMode;
        this.databaseEnabled = databaseEnabled;
        this.jobNodes = jobNodes;
        this.debugMode = debugMode;
        this.cloudMode = cloudMode;
    }

    public String getProductId() {
        return productId;
    }

    public String getProductName() {
        return productName;
    }

    public long getVersion() {
        return version;
    }

    public boolean isValidLicense() {
        return validLicense;
    }

    public boolean isLimitedMode() {
        return limitedMode;
    }

    public void setLimitedMode(boolean limitedMode) {
        this.limitedMode = limitedMode;
    }

    public boolean isDatabaseEnabled() {
        return databaseEnabled;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public void setVersion(long version) {
        this.version = version;
    }

    public void setServerFacadeVersion(long serverFacadeVersion) {
        this.serverFacadeVersion = serverFacadeVersion;
    }

    public long getServerFacadeVersion() {
        return serverFacadeVersion;
    }

    public void setValidLicense(boolean validLicense) {
        this.validLicense = validLicense;
    }

    public void setDatabaseEnabled(boolean databaseEnabled) {
        this.databaseEnabled = databaseEnabled;
    }

    public boolean isDebugMode() {
        return debugMode;
    }

    public void setDebugMode(boolean debugMode) {
        this.debugMode = debugMode;
    }

    public int getJobNodes() {
        return jobNodes;
    }

    public void setJobNodes(int jobNodes) {
        this.jobNodes = jobNodes;
    }

    public boolean isCloudMode() {
        return cloudMode;
    }
    
    public void setCloudMode(boolean cloudMode) {
        this.cloudMode = cloudMode;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (cloudMode ? 1231 : 1237);
        result = prime * result + (databaseEnabled ? 1231 : 1237);
        result = prime * result + (debugMode ? 1231 : 1237);
        result = prime * result + jobNodes;
        result = prime * result + (limitedMode ? 1231 : 1237);
        result = prime * result + ((productId == null) ? 0 : productId.hashCode());
        result = prime * result + ((productName == null) ? 0 : productName.hashCode());
        result = prime * result + (int) (serverFacadeVersion ^ (serverFacadeVersion >>> 32));
        result = prime * result + (validLicense ? 1231 : 1237);
        result = prime * result + (int) (version ^ (version >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerInformation other = (ServerInformation) obj;
        if (cloudMode != other.cloudMode)
            return false;
        if (databaseEnabled != other.databaseEnabled)
            return false;
        if (debugMode != other.debugMode)
            return false;
        if (jobNodes != other.jobNodes)
            return false;
        if (limitedMode != other.limitedMode)
            return false;
        if (productId == null) {
            if (other.productId != null)
                return false;
        }
        else if (!productId.equals(other.productId))
            return false;
        if (productName == null) {
            if (other.productName != null)
                return false;
        }
        else if (!productName.equals(other.productName))
            return false;
        if (serverFacadeVersion != other.serverFacadeVersion)
            return false;
        if (validLicense != other.validLicense)
            return false;
        if (version != other.version)
            return false;
        return true;
    }

}
