package com.clcbio.client.thin.model.admin;

import com.clcbio.client.thin.model.admin.configuration.GwtClone;
import com.clcbio.client.thin.model.admin.configuration.ServerConfiguration;
import com.google.gwt.user.client.rpc.IsSerializable;

public class ThinPluginDescriptor implements IsSerializable, GwtClone {
    private String id;
    private boolean isDenied;
    private String deniedMsg;
    private String description;
    private String name;
    private String vendorName;
    private ThinPluginVersion version;
    private String buildId = "";
    private boolean disabled;
    private boolean isBeta;
    private int betaVersion = 0;
    private long betaExpires = 0;
    private String cpaFile;
    private ThinPluginClassification classification;

    public ThinPluginDescriptor() {
        super();
    }

    public ThinPluginDescriptor(ThinPluginDescriptor cloneSource) {
        super();
        this.id = cloneSource.id;
        this.isDenied = cloneSource.isDenied;
        this.deniedMsg = cloneSource.deniedMsg;
        this.description = cloneSource.description;
        this.name = cloneSource.name;
        this.vendorName = cloneSource.vendorName;
        this.version = new ThinPluginVersion(cloneSource.version);
        this.buildId = cloneSource.buildId;
        this.disabled = cloneSource.disabled;
        this.isBeta = cloneSource.isBeta;
        this.betaVersion = cloneSource.betaVersion;
        this.betaExpires = cloneSource.betaExpires;
        this.classification = cloneSource.classification;
        this.cpaFile = cloneSource.cpaFile;
    }

    public String getCpaFile() {
        return cpaFile;
    }
    
    public void setCpaFile(String cpaFile) {
        this.cpaFile = cpaFile;
    }
    
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getVendorName() {
        return vendorName;
    }

    public void setVendorName(String vendorName) {
        this.vendorName = vendorName;
    }

    public ThinPluginVersion getVersion() {
        return version;
    }

    public void setVersion(ThinPluginVersion version) {
        this.version = version;
    }

    public String getBuildId() {
        return buildId;
    }

    public void setBuildId(String buildId) {
        this.buildId = buildId;
    }
    
    public boolean isDenied() {
        return isDenied;
    }

    public void setDenied(boolean isDenied) {
        this.isDenied = isDenied;
    }

    public String getDeniedMsg() {
        return deniedMsg;
    }

    public void setDeniedMsg(String deniedMsg) {
        this.deniedMsg = deniedMsg;
    }

    public boolean isDisabled() {
        return disabled;
    }

    public void setDisabled(boolean disabled) {
        this.disabled = disabled;
    }

    public boolean isBeta() {
        return isBeta;
    }

    public void setBeta(boolean isBeta) {
        this.isBeta = isBeta;
    }

    public int getBetaVersion() {
        return betaVersion;
    }

    public void setBetaVersion(int betaVersion) {
        this.betaVersion = betaVersion;
    }

    public long getBetaExpires() {
        return betaExpires;
    }

    public void setBetaExpires(long betaExpires) {
        this.betaExpires = betaExpires;
    }

    public ThinPluginClassification getClassification() {
        return classification;
    }

    public void setClassification(ThinPluginClassification classification) {
        this.classification = classification;
    }


    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (betaExpires ^ (betaExpires >>> 32));
        result = prime * result + betaVersion;
        result = prime * result + ((buildId == null) ? 0 : buildId.hashCode());
        result = prime * result + ((classification == null) ? 0 : classification.hashCode());
        result = prime * result + ((cpaFile == null) ? 0 : cpaFile.hashCode());
        result = prime * result + ((deniedMsg == null) ? 0 : deniedMsg.hashCode());
        result = prime * result + ((description == null) ? 0 : description.hashCode());
        result = prime * result + (disabled ? 1231 : 1237);
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        result = prime * result + (isBeta ? 1231 : 1237);
        result = prime * result + (isDenied ? 1231 : 1237);
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((vendorName == null) ? 0 : vendorName.hashCode());
        result = prime * result + ((version == null) ? 0 : version.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ThinPluginDescriptor other = (ThinPluginDescriptor) obj;
        if (betaExpires != other.betaExpires)
            return false;
        if (betaVersion != other.betaVersion)
            return false;
        if (buildId == null) {
            if (other.buildId != null)
                return false;
        }
        else if (!buildId.equals(other.buildId))
            return false;
        if (classification != other.classification)
            return false;
        if (cpaFile == null) {
            if (other.cpaFile != null)
                return false;
        }
        else if (!cpaFile.equals(other.cpaFile))
            return false;
        if (deniedMsg == null) {
            if (other.deniedMsg != null)
                return false;
        }
        else if (!deniedMsg.equals(other.deniedMsg))
            return false;
        if (description == null) {
            if (other.description != null)
                return false;
        }
        else if (!description.equals(other.description))
            return false;
        if (disabled != other.disabled)
            return false;
        if (id == null) {
            if (other.id != null)
                return false;
        }
        else if (!id.equals(other.id))
            return false;
        if (isBeta != other.isBeta)
            return false;
        if (isDenied != other.isDenied)
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        }
        else if (!name.equals(other.name))
            return false;
        if (vendorName == null) {
            if (other.vendorName != null)
                return false;
        }
        else if (!vendorName.equals(other.vendorName))
            return false;
        if (version == null) {
            if (other.version != null)
                return false;
        }
        else if (!version.equals(other.version))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "ThinPluginDescriptor [id=" + id + ", isDenied=" + isDenied + ", deniedMsg=" + deniedMsg + ", description="
                + description + ", name=" + name + ", vendorName=" + vendorName + ", version=" + version + ", buildId=" + buildId
                + ", disabled=" + disabled + ", isBeta=" + isBeta + ", betaVersion=" + betaVersion + ", betaExpires=" + betaExpires
                + ", classification=" + classification +", cpaFile=" + cpaFile + "]";
    }

    public ServerConfiguration createClone() {
        // TODO Auto-generated method stub
        return null;
    }
    
}
