package com.clcbio.client.thin.model.admin;

import com.google.gwt.user.client.rpc.IsSerializable;

public class ThinPluginVersion implements IsSerializable{
    private int major = 0;
    private int minor = 0;
    private int rev = 0;
    
    public ThinPluginVersion() {
    }
    
    public ThinPluginVersion(int major, int minor, int rev) {
        this.major = major;
        this.minor = minor;
        this.rev = rev;
    }
    
    
    public ThinPluginVersion(ThinPluginVersion cloneSource) {
        this.major = cloneSource.major;
        this.minor = cloneSource.minor;
        this.rev = cloneSource.rev;
    }

    public int getMajor() {
        return major;
    }

    public void setMajor(int major) {
        this.major = major;
    }

    public int getMinor() {
        return minor;
    }

    public void setMinor(int minor) {
        this.minor = minor;
    }

    public int getRev() {
        return rev;
    }

    public void setRev(int rev) {
        this.rev = rev;
    }

    public String toString() {
        String str = major + "." + minor;
        if (rev != 0) {
            str = str + "." + rev;
        }
        return str;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + major;
        result = prime * result + minor;
        result = prime * result + rev;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ThinPluginVersion other = (ThinPluginVersion) obj;
        if (major != other.major)
            return false;
        if (minor != other.minor)
            return false;
        if (rev != other.rev)
            return false;
        return true;
    }
    
}