package com.clcbio.client.thin.model.admin.configuration.subsystem.authentication;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class Group implements CommonBeanSerialization {
    private static final long serialVersionUID = -6079334295556862835L;
    private Set<String> members;
    private String name;

    public Group() {
        members = new HashSet<String>();
        name = "";
    }

    public Group(String name, Set<String> members) {
        super();
        this.members = members;
        this.name = name;
    }

    public Set<String> getMembers() {
        return members;
    }

    public void setMembers(Set<String> members) {
        this.members = members;

    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((members == null) ? 0 : members.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        Group other = (Group) obj;
        if (members == null) {
            if (other.members != null) {
                return false;
            }
        }
        else if (!members.equals(other.members)) {
            return false;
        }
        if (name == null) {
            if (other.name != null) {
                return false;
            }
        }
        else if (!name.equals(other.name)) {
            return false;
        }
        return true;
    }
    
    public Group clone(){       
        Set<String> memberClone =  new HashSet<String>();
        Iterator<String> it = members.iterator();
        while (it.hasNext()) {
            memberClone.add(it.next());
        }
        return new Group(name, memberClone);
    }

}
