package com.clcbio.client.thin.model.admin.configuration.subsystem.cluster;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.ServerCommandReference;

public class Node implements CommonBeanSerialization {

    private static final long serialVersionUID = 9010681008653446470L;
    private String serviceHost;
    private String servicePort;
    private String displayName;
    private List<String> supportedCommandIds;
    private String nodeGuid;

    public Node() {
        serviceHost = "";
        servicePort = "";
        displayName = "";
        nodeGuid = "";
        supportedCommandIds = new ArrayList<String>();
    }

    public Node(String nodeGuid) {
        super();
        this.nodeGuid = nodeGuid;
    }

    public boolean acceptsCommand(ServerCommandReference commandReference) {
        return false;
    }

    public String getServiceHost() {
        return serviceHost;
    }

    public void setServiceHost(String serviceHost) {
        this.serviceHost = serviceHost;
    }

    public String getServicePort() {
        return servicePort;
    }

    public void setServicePort(String servicePort) {
        this.servicePort = servicePort;
    }

    public List<String> getSupportedCommandIds() {
        return supportedCommandIds;
    }

    public void setSupportedCommandIds(List<String> supportedCommandIds) {
        this.supportedCommandIds = supportedCommandIds;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Node) {
            Node otherConf = (Node) obj;
            boolean same = true;
            same = same && this.getDisplayName().equals(otherConf.getDisplayName());
            same = same && this.getNodeGuid().equals(otherConf.getNodeGuid());
            same = same && this.getServiceHost().equals(otherConf.getServiceHost());
            same = same && this.getServicePort().equals(otherConf.getServicePort());
            same = same && this.getSupportedCommandIds().equals(otherConf.getSupportedCommandIds());
            return same;
        }
        else {
            return false;
        }
    }

    public String getNodeGuid() {
        return nodeGuid;
    }

    public void setNodeGuid(String nodeGuid) {
        this.nodeGuid = nodeGuid;
    }

    @Override
    public String toString() {
        return "serviceHost=" + serviceHost + ",servicePort=" + servicePort + ",displayName=" + displayName + ",supportedCommandIds="
                + supportedCommandIds + ",nodeGuid=" + nodeGuid;
    }

}
