package com.clcbio.client.thin.model.admin.configuration.subsystem.directcommand;

import java.util.HashMap;
import java.util.Map;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.admin.configuration.GwtClone;
import com.clcbio.client.thin.model.admin.configuration.ServerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.ServerConfigurationModule;
import com.clcbio.client.thin.model.serialization.SerializedBeanXML;

public class DirectCommandConfiguration extends ServerConfiguration implements CommonBeanSerialization, GwtClone {
    private static final long serialVersionUID = -8401076849980201243L;
    private Map<String, SerializedBeanXML> directCommandsPersistedBeanFieldsMap;
    public DirectCommandConfiguration() {
        super();
        directCommandsPersistedBeanFieldsMap = new HashMap<String, SerializedBeanXML>();
    }

    private DirectCommandConfiguration(Map<String, SerializedBeanXML> directCommandsPersistedBeanFieldsMap) {
        super();
        this.directCommandsPersistedBeanFieldsMap = new HashMap<String, SerializedBeanXML>(directCommandsPersistedBeanFieldsMap);
    }

    public ServerConfiguration createClone() {
        // TODO: Create bean-cloning
        return new DirectCommandConfiguration(directCommandsPersistedBeanFieldsMap);
    }

    @Override
    public ServerConfigurationModule getModuleType() {
        return ServerConfigurationModule.SUBSYSTEM_DIRECT_COMMAND;
    }

    public Map<String, SerializedBeanXML> getDirectCommandsPersistedBeanFieldsMap() {
        return directCommandsPersistedBeanFieldsMap;
    }

    public void setDirectCommandsPersistedBeanFieldsMap(Map<String, SerializedBeanXML> directCommandsPersistedBeanFieldsMap) {
        this.directCommandsPersistedBeanFieldsMap = directCommandsPersistedBeanFieldsMap;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result
                + ((directCommandsPersistedBeanFieldsMap == null) ? 0 : directCommandsPersistedBeanFieldsMap.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        DirectCommandConfiguration other = (DirectCommandConfiguration) obj;
        if (directCommandsPersistedBeanFieldsMap == null) {
            if (other.directCommandsPersistedBeanFieldsMap != null)
                return false;
        }
        else if (!directCommandsPersistedBeanFieldsMap.equals(other.directCommandsPersistedBeanFieldsMap))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "DirectCommandConfiguration [directCommandsPersistedBeanFieldsMap=" + directCommandsPersistedBeanFieldsMap + "]";
    }
    
}
