package com.clcbio.client.thin.model.admin.configuration.subsystem.grid;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.admin.configuration.GwtClone;
import com.clcbio.client.thin.model.admin.configuration.ServerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.ServerConfigurationModule;

public class GridConfiguration extends ServerConfiguration implements CommonBeanSerialization, GwtClone {

    private static final long serialVersionUID = 8557516257040141018L;
    private List<GridPreset> gridPresets;

    public GridConfiguration() {
        super();
        gridPresets = new ArrayList<GridPreset>();
    }

    @Override
    public ServerConfigurationModule getModuleType() {
        return ServerConfigurationModule.SUBSYSTEM_GRID;
    }

    public ServerConfiguration createClone() {
        ArrayList<GridPreset> pClone = new ArrayList<GridPreset>();
        for (GridPreset p : gridPresets) {
            pClone.add(p.createClone());
        }
        GridConfiguration clone = new GridConfiguration();
        clone.setGridPresets(pClone);
        return clone;
    }

    public List<GridPreset> getGridPresets() {
        return gridPresets;
    }

    public void setGridPresets(List<GridPreset> gridPresets) {
        this.gridPresets = gridPresets;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((gridPresets == null) ? 0 : gridPresets.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        GridConfiguration other = (GridConfiguration) obj;
        if (gridPresets == null) {
            if (other.gridPresets != null) {
                return false;
            }
        }
        else if (!gridPresets.equals(other.gridPresets)) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "GridConfiguration [gridPresets=" + gridPresets + "]";
    }
}
