package com.clcbio.client.thin.model.admin.configuration.subsystem.grid;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class GridPreset implements CommonBeanSerialization {

    private static final long serialVersionUID = -5748457912989047782L;
    private String gridSharedWorkDir;
    private String gridExecuteablePath;
    private String jobCategory;
    private String nativeSpecification;
    private String presetName;
    private String drmaaNativeLibPath;
    private GridType gridType;

    public GridPreset() {
        super();
        gridSharedWorkDir = "";
        gridExecuteablePath = "";
        jobCategory = "";
        nativeSpecification = "";
        presetName = "";
        drmaaNativeLibPath = "";
        gridType = GridType.DRMAA;
    }

    public GridType getGridType() {
        return gridType;
    }

    public void setGridType(GridType gridType) {
        this.gridType = gridType;
    }

    public GridPreset(String gridSharedWorkDir, String gridExecuteablePath, String jobCategory, String nativeSpecification,
            String presetName, String drmaaNativeLibPath, GridType gridType) {
        this();
        this.gridSharedWorkDir = gridSharedWorkDir;
        this.gridExecuteablePath = gridExecuteablePath;
        this.jobCategory = jobCategory;
        this.nativeSpecification = nativeSpecification;
        this.presetName = presetName;
        this.drmaaNativeLibPath = drmaaNativeLibPath;
        this.gridType = gridType;
    }

    public GridPreset(GridPreset preset) {
        this.gridSharedWorkDir = preset.gridSharedWorkDir;
        this.gridExecuteablePath = preset.gridExecuteablePath;
        this.jobCategory = preset.jobCategory;
        this.nativeSpecification = preset.nativeSpecification;
        this.presetName = preset.presetName;
        this.drmaaNativeLibPath = preset.drmaaNativeLibPath;
        this.gridType = preset.gridType;
    }

    public GridPreset createClone() {
        return new GridPreset(gridSharedWorkDir, gridExecuteablePath, jobCategory, nativeSpecification, presetName,
                drmaaNativeLibPath, gridType);
    }

    public String getJobCategory() {
        return jobCategory;
    }

    public void setJobCategory(String jobCategory) {
        this.jobCategory = jobCategory;
    }

    public String getNativeSpecification() {
        return nativeSpecification;
    }

    public void setNativeSpecification(String nativeSpecification) {
        this.nativeSpecification = nativeSpecification;
    }

    public String getGridSharedWorkDir() {
        return gridSharedWorkDir;
    }

    public void setGridSharedWorkDir(String gridSharedWorkDir) {
        this.gridSharedWorkDir = gridSharedWorkDir;
    }

    public String getGridExecuteablePath() {
        return gridExecuteablePath;
    }

    public void setGridExecuteablePath(String gridExecuteablePath) {
        this.gridExecuteablePath = gridExecuteablePath;
    }

    public String getPresetName() {
        return presetName;
    }

    public void setPresetName(String presetName) {
        this.presetName = presetName;
    }

    public String getDrmaaNativeLibPath() {
        return drmaaNativeLibPath;
    }

    public void setDrmaaNativeLibPath(String drmaaNativeLibPath) {
        this.drmaaNativeLibPath = drmaaNativeLibPath;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((drmaaNativeLibPath == null) ? 0 : drmaaNativeLibPath.hashCode());
        result = prime * result + ((gridExecuteablePath == null) ? 0 : gridExecuteablePath.hashCode());
        result = prime * result + ((gridSharedWorkDir == null) ? 0 : gridSharedWorkDir.hashCode());
        result = prime * result + ((jobCategory == null) ? 0 : jobCategory.hashCode());
        result = prime * result + ((nativeSpecification == null) ? 0 : nativeSpecification.hashCode());
        result = prime * result + ((presetName == null) ? 0 : presetName.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        GridPreset other = (GridPreset) obj;
        if (drmaaNativeLibPath == null) {
            if (other.drmaaNativeLibPath != null) {
                return false;
            }
        }
        else if (!drmaaNativeLibPath.equals(other.drmaaNativeLibPath)) {
            return false;
        }
        if (gridExecuteablePath == null) {
            if (other.gridExecuteablePath != null) {
                return false;
            }
        }
        else if (!gridExecuteablePath.equals(other.gridExecuteablePath)) {
            return false;
        }
        if (gridSharedWorkDir == null) {
            if (other.gridSharedWorkDir != null) {
                return false;
            }
        }
        else if (!gridSharedWorkDir.equals(other.gridSharedWorkDir)) {
            return false;
        }
        if (jobCategory == null) {
            if (other.jobCategory != null) {
                return false;
            }
        }
        else if (!jobCategory.equals(other.jobCategory)) {
            return false;
        }
        if (nativeSpecification == null) {
            if (other.nativeSpecification != null) {
                return false;
            }
        }
        else if (!nativeSpecification.equals(other.nativeSpecification)) {
            return false;
        }
        if (presetName == null) {
            if (other.presetName != null) {
                return false;
            }
        }
        else if (!presetName.equals(other.presetName)) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "GridPreset [gridSharedWorkDir=" + gridSharedWorkDir + ", gridExecuteablePath=" + gridExecuteablePath
                + ", jobCategory=" + jobCategory + ", nativeSpecification=" + nativeSpecification + ", presetName=" + presetName
                + ", drmaaNativeLibPath=" + drmaaNativeLibPath + ", gridType=" + gridType + "]";
    }

}
