package com.clcbio.client.thin.model.admin.configuration.subsystem.permission;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class GrantedGroupsKey implements CommonBeanSerialization{
    private static final long serialVersionUID = -4643313753397114726L;
    private String key;
    private KeyType keyType;
    private String subType;
    private String description;
    
    public GrantedGroupsKey(GrantedGroupsKey cloneFrom) {
        key = cloneFrom.getKey();
        keyType = cloneFrom.getKeyType();
        subType = cloneFrom.getSubType();
        description = cloneFrom.getDescription();
    }
    public GrantedGroupsKey() {
        key = "";
        keyType = KeyType.PERMISION_CONFIGURATION;
        subType = "";
        description = "";
    }
    
    public boolean isSameType(GrantedGroupsKey grantedGroupsKey){
        return grantedGroupsKey.getKey().equals(key) && grantedGroupsKey.getKeyType().equals(keyType);
    }
    
    public String getKey() {
        return key;
    }
    public void setKey(String key) {
        this.key = key;
    }
    public KeyType getKeyType() {
        return keyType;
    }
    public void setKeyType(KeyType keyType) {
        this.keyType = keyType;
    }
    public String getSubType() {
        return subType;
    }
    public void setSubType(String subType) {
        this.subType = subType;
    }
    
    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((key == null) ? 0 : key.hashCode());
        result = prime * result + ((keyType == null) ? 0 : keyType.hashCode());
        result = prime * result + ((subType == null) ? 0 : subType.hashCode());
        return result;
    }
    /**
     * Deliberately omit description
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        GrantedGroupsKey other = (GrantedGroupsKey) obj;
        if (key == null) {
            if (other.key != null)
                return false;
        }
        else if (!key.equals(other.key))
            return false;
        if (keyType != other.keyType)
            return false;
        if (subType == null) {
            if (other.subType != null)
                return false;
        }
        else if (!subType.equals(other.subType))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "GrantedGroupsKey [key=" + key + ", keyType=" + keyType + ", subType=" + subType + ", description=" + description + "]";
    }
    
}
