package com.clcbio.client.thin.model.admin.configuration.subsystem.safefiles;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.admin.configuration.GwtClone;
import com.clcbio.client.thin.model.admin.configuration.ServerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.ServerConfigurationModule;

public class SafeFileDirectories extends ServerConfiguration implements CommonBeanSerialization, GwtClone {

    private static final long serialVersionUID = -7067469438147930502L;
    private List<SafeFileDirectory> safeFileDirectories;

    public SafeFileDirectories() {
        super();
        safeFileDirectories = new ArrayList<SafeFileDirectory>();
    }

    private SafeFileDirectories(List<SafeFileDirectory> safeDirectoriesPaths) {
        super();
        this.safeFileDirectories = new ArrayList<SafeFileDirectory>(safeDirectoriesPaths);
    }

    public ServerConfiguration createClone() {
        List<SafeFileDirectory> clones = new ArrayList<SafeFileDirectory>();
        for (SafeFileDirectory safeFileDirectory : safeFileDirectories) {
            clones.add(new SafeFileDirectory(safeFileDirectory));
        }
        return new SafeFileDirectories(clones);
    }

    public List<SafeFileDirectory> getSafeFileDirectories() {
        return safeFileDirectories;
    }

    public void setSafeFileDirectories(List<SafeFileDirectory> safeFileDirectories) {
        this.safeFileDirectories = safeFileDirectories;
    }

    @Override
    public ServerConfigurationModule getModuleType() {
        return ServerConfigurationModule.SUBSYSTEM_SAFE_FILES;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof SafeFileDirectories) {
            return safeFileDirectories.equals(((SafeFileDirectories) obj).getSafeFileDirectories());
        }
        else {
            return false;
        }
    }

    @Override
    public String toString() {
        return super.toString() + ", safeDirectoriesPaths=" + safeFileDirectories.toString();
    }

}
