package com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.ServerCommandReference;

public class InstalledTemplateCommand implements CommonBeanSerialization {
    private static final long serialVersionUID = -950339216479582725L;
    private ServerCommandReference newTemplateCommand;
    private String templateCommandIdBasedUpon;
    private boolean enabled;

    public InstalledTemplateCommand() {
        super();
        newTemplateCommand = new ServerCommandReference();
        templateCommandIdBasedUpon = "";
        enabled = true;
    }

    public InstalledTemplateCommand(ServerCommandReference command) {
        newTemplateCommand = command;
        templateCommandIdBasedUpon = command.getId();
        enabled = true;
    }

    public InstalledTemplateCommand(String templateCommandIdBasedUpon, ServerCommandReference command) {
        newTemplateCommand = command;
        this.templateCommandIdBasedUpon = templateCommandIdBasedUpon;
        enabled = true;
    }

    public InstalledTemplateCommand(InstalledTemplateCommand cloneSource) {
        templateCommandIdBasedUpon = cloneSource.getTemplateCommandIdBasedUpon();
        enabled = cloneSource.isEnabled();
        // this is where the configurations GwtClone() meets the APIs Clone4log() :-/
        newTemplateCommand = cloneSource.getNewTemplateCommand().clone4log();
    }

    public ServerCommandReference getNewTemplateCommand() {
        return newTemplateCommand;
    }

    public void setNewTemplateCommand(ServerCommandReference newTemplateCommand) {
        this.newTemplateCommand = newTemplateCommand;
    }

    public String getTemplateCommandIdBasedUpon() {
        return templateCommandIdBasedUpon;
    }

    public void setTemplateCommandIdBasedUpon(String templateCommandIdBasedUpon) {
        this.templateCommandIdBasedUpon = templateCommandIdBasedUpon;
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (enabled ? 1231 : 1237);
        result = prime * result + ((newTemplateCommand == null) ? 0 : newTemplateCommand.hashCode());
        result = prime * result + ((templateCommandIdBasedUpon == null) ? 0 : templateCommandIdBasedUpon.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        InstalledTemplateCommand other = (InstalledTemplateCommand) obj;
        if (enabled != other.enabled)
            return false;
        if (newTemplateCommand == null) {
            if (other.newTemplateCommand != null)
                return false;
        }
        else if (!newTemplateCommand.equals(other.newTemplateCommand))
            return false;
        if (templateCommandIdBasedUpon == null) {
            if (other.templateCommandIdBasedUpon != null)
                return false;
        }
        else if (!templateCommandIdBasedUpon.equals(other.templateCommandIdBasedUpon))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "InstalledTemplateCommand [newTemplateCommand=" + newTemplateCommand + ", templateCommandIdBasedUpon="
                + templateCommandIdBasedUpon + ", enabled=" + enabled + "]";
    }

}
