package com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.admin.configuration.GwtClone;
import com.clcbio.client.thin.model.admin.configuration.ServerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.ServerConfigurationModule;

public class TemplateCommandManagerConfiguration extends ServerConfiguration implements CommonBeanSerialization, GwtClone {
    private static final long serialVersionUID = -5465170199371744419L;
    private List<InstalledTemplateCommand> installedTemplateCommands;

    public TemplateCommandManagerConfiguration() {
        super();
        installedTemplateCommands = new ArrayList<InstalledTemplateCommand>();
    }

    public List<InstalledTemplateCommand> getInstalledTemplateCommands() {
        return installedTemplateCommands;
    }

    public void setInstalledTemplateCommands(List<InstalledTemplateCommand> installedTemplateCommands) {
        this.installedTemplateCommands = installedTemplateCommands;
    }

    @Override
    public ServerConfigurationModule getModuleType() {
        return ServerConfigurationModule.SUBSYSTEM_TEMPLATE_COMMAND;
    }

    public ServerConfiguration createClone() {
        TemplateCommandManagerConfiguration clone = new TemplateCommandManagerConfiguration();
        clone.setInstalledTemplateCommands(new ArrayList<InstalledTemplateCommand>(installedTemplateCommands));
        return clone;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((installedTemplateCommands == null) ? 0 : installedTemplateCommands.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        TemplateCommandManagerConfiguration other = (TemplateCommandManagerConfiguration) obj;
        if (installedTemplateCommands == null) {
            if (other.installedTemplateCommands != null) {
                return false;
            }
        }
        else if (!installedTemplateCommands.equals(other.installedTemplateCommands)) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "TemplateCommandManagerConfiguration [installedTemplateCommands=" + installedTemplateCommands + "]";
    }

}
