package com.clcbio.client.thin.model.admin.configuration.subsystem.workflow;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.admin.ThinPluginDescripterBinaryIcon;
import com.clcbio.client.thin.model.admin.ThinPluginDescripterReferencedIcon;
import com.clcbio.client.thin.model.admin.ThinPluginDescriptor;
import com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand.InstalledTemplateCommand;

public class InstalledWorkflowPlugin implements CommonBeanSerialization{
    private static final long serialVersionUID = -7913405131809614502L;
    private ThinPluginDescriptor workflowPluginDescriptor;
    private InstalledTemplateCommand installedWorkflowCommand;
    public InstalledWorkflowPlugin() {
        super();
    }
    public InstalledWorkflowPlugin(InstalledWorkflowPlugin sourceWorkflowPlugin) {
        ThinPluginDescriptor sourceDesc = sourceWorkflowPlugin.getWorkflowPluginDescriptor();
        if(sourceDesc instanceof ThinPluginDescripterReferencedIcon){
            workflowPluginDescriptor = new ThinPluginDescripterBinaryIcon((ThinPluginDescripterBinaryIcon) sourceDesc);
        }
        else if(sourceDesc instanceof ThinPluginDescripterReferencedIcon){
            workflowPluginDescriptor = new ThinPluginDescripterReferencedIcon((ThinPluginDescripterReferencedIcon) sourceDesc);
        }
        else{
            workflowPluginDescriptor = new ThinPluginDescriptor(sourceDesc);            
        }
        installedWorkflowCommand = new InstalledTemplateCommand(sourceWorkflowPlugin.getInstalledWorkflowCommand());
    }
    public ThinPluginDescriptor getWorkflowPluginDescriptor() {
        return workflowPluginDescriptor;
    }
    public void setWorkflowPluginDescriptor(ThinPluginDescriptor workflowPluginDescriptor) {
        this.workflowPluginDescriptor = workflowPluginDescriptor;
    }
    public InstalledTemplateCommand getInstalledWorkflowCommand() {
        return installedWorkflowCommand;
    }
    public void setInstalledWorkflowCommand(InstalledTemplateCommand installedWorkflowCommand) {
        this.installedWorkflowCommand = installedWorkflowCommand;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((installedWorkflowCommand == null) ? 0 : installedWorkflowCommand.hashCode());
        result = prime * result + ((workflowPluginDescriptor == null) ? 0 : workflowPluginDescriptor.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        InstalledWorkflowPlugin other = (InstalledWorkflowPlugin) obj;
        if (installedWorkflowCommand == null) {
            if (other.installedWorkflowCommand != null)
                return false;
        }
        else if (!installedWorkflowCommand.equals(other.installedWorkflowCommand))
            return false;
        if (workflowPluginDescriptor == null) {
            if (other.workflowPluginDescriptor != null)
                return false;
        }
        else if (!workflowPluginDescriptor.equals(other.workflowPluginDescriptor))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "InstalledWorkflowPlugin [workflowPluginDescriptor=" + workflowPluginDescriptor + ", installedWorkflowCommand="
                + installedWorkflowCommand + "]";
    }
    
}
