package com.clcbio.client.thin.model.admin.configuration.system;

import com.google.gwt.user.client.rpc.IsSerializable;

public class FileSystemPersistenceModelConf implements IsSerializable, ModelConfigurationAttributes {
    private String pathName;
    private boolean enabled;
    private String persistenceModelId;
    private boolean canRead;
    private boolean canWrite;
    private boolean permissionsEnabled;

    public String getPersistenceModelId() {
        return persistenceModelId;
    }

    public void setPersistenceModelId(String persistenceModelId) {
        this.persistenceModelId = persistenceModelId;
    }

    public FileSystemPersistenceModelConf() {
        pathName = "";
        enabled = true;
        canRead = true;
        canWrite = true;
        permissionsEnabled = false;
    }

    public FileSystemPersistenceModelConf(String pathName) {
        this.pathName = pathName;
        enabled = true;
        canRead = true;
        canWrite = true;
        permissionsEnabled = false;
    }

    /**
     * @return the pathName
     */
    public String getPathName() {
        return pathName;
    }

    /**
     * @param pathName
     *            the pathName to set
     */
    public void setPathName(String pathName) {
        this.pathName = pathName;
    }

    /**
     * @return the enabled
     */
    public boolean isEnabled() {
        return enabled;
    }

    /**
     * @param enabled
     *            the enabled to set
     */
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    public FileSystemPersistenceModelConf createClone() {
        FileSystemPersistenceModelConf clone = new FileSystemPersistenceModelConf();
        clone.setEnabled(enabled);
        clone.setPathName(pathName);
        clone.setPersistenceModelId(persistenceModelId);
        clone.setCanRead(canRead);
        clone.setCanWrite(canWrite);
        return clone;
    }

    public boolean isCanRead() {
        return canRead;
    }

    public void setCanRead(boolean canRead) {
        this.canRead = canRead;
    }

    public boolean isCanWrite() {
        return canWrite;
    }

    public void setCanWrite(boolean canWrite) {
        this.canWrite = canWrite;
    }

    public boolean isPermissionsEnabled() {
        return permissionsEnabled;
    }

    public void setPermissionsEnabled(boolean permissionsEnabled) {
        this.permissionsEnabled = permissionsEnabled;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (canRead ? 1231 : 1237);
        result = prime * result + (canWrite ? 1231 : 1237);
        result = prime * result + (enabled ? 1231 : 1237);
        result = prime * result + ((pathName == null) ? 0 : pathName.hashCode());
        result = prime * result + (permissionsEnabled ? 1231 : 1237);
        result = prime * result + ((persistenceModelId == null) ? 0 : persistenceModelId.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        FileSystemPersistenceModelConf other = (FileSystemPersistenceModelConf) obj;
        if (canRead != other.canRead)
            return false;
        if (canWrite != other.canWrite)
            return false;
        if (enabled != other.enabled)
            return false;
        if (pathName == null) {
            if (other.pathName != null)
                return false;
        }
        else if (!pathName.equals(other.pathName))
            return false;
        if (permissionsEnabled != other.permissionsEnabled)
            return false;
        if (persistenceModelId == null) {
            if (other.persistenceModelId != null)
                return false;
        }
        else if (!persistenceModelId.equals(other.persistenceModelId))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "FileSystemPersistenceModelConf [pathName=" + pathName + ", enabled=" + enabled + ", persistenceModelId="
                + persistenceModelId + ", canRead=" + canRead + ", canWrite=" + canWrite + ", permissionsEnabled="
                + permissionsEnabled + "]";
    }

}
