package com.clcbio.client.thin.model.admin.configuration.system;

import com.google.gwt.user.client.rpc.IsSerializable;

public class SMTPConfiguration implements IsSerializable {
    private String outGoingSMTPServer;
    private boolean useAuthentication;
    private String userName;
    private String password;
    private String senderEmailAddress;

    public SMTPConfiguration() {
        outGoingSMTPServer = "";
        useAuthentication = false;
        password = "";
        userName = "";
        senderEmailAddress = "";
    }

    public String getOutGoingSMTPServer() {
        return outGoingSMTPServer;
    }

    public void setOutGoingSMTPServer(String outGoingSMTPServer) {
        this.outGoingSMTPServer = outGoingSMTPServer;
    }

    public boolean isUseAuthentication() {
        return useAuthentication;
    }

    public void setUseAuthentication(boolean useAuthentication) {
        this.useAuthentication = useAuthentication;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public SMTPConfiguration createClone() {
        SMTPConfiguration clone = new SMTPConfiguration();
        clone.setOutGoingSMTPServer(getOutGoingSMTPServer());
        clone.setPassword(getPassword());
        clone.setUseAuthentication(isUseAuthentication());
        clone.setUserName(getUserName());
        return clone;
    }

    @Override
    public String toString() {
        return "outGoingSMTPServer=" + outGoingSMTPServer + ", useAuthentication=" + useAuthentication + ", userName=" + userName;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof SMTPConfiguration) {
            SMTPConfiguration otherConf = (SMTPConfiguration) obj;
            boolean same = true;
            same = same && this.getOutGoingSMTPServer().equals(otherConf.getOutGoingSMTPServer());
            same = same && this.getPassword().equals(otherConf.getPassword());
            same = same && this.getUserName().equals(otherConf.getUserName());
            same = same && this.getSenderEmailAddress().equals(otherConf.getSenderEmailAddress());
            same = same && this.isUseAuthentication() == otherConf.isUseAuthentication();
            return same;
        }
        else {
            return false;
        }
    }

    public String getSenderEmailAddress() {
        return senderEmailAddress;
    }

    public void setSenderEmailAddress(String tmpEmailAddress) {
        this.senderEmailAddress = tmpEmailAddress;
    }

}
