package com.clcbio.client.thin.model.admin.configuration.system;

import java.util.Arrays;

import com.google.gwt.user.client.rpc.IsSerializable;

public class SimpleDBPersistenceModelConf implements IsSerializable, ModelConfigurationAttributes {
    private boolean enabled;
    private String host;
    private String port;
    private String username;
    private String password;
    private int selectedDriver;
    private String databaseName;
    private String[] drivers;
    private String persistenceModelId;

    public SimpleDBPersistenceModelConf(String host, String port, String databaseName, String username, String password, String[] drivers,
            int selectedDriver, String persistenceModelId) {
        this.host = host;
        this.port = port;
        this.username = username;
        this.password = password;
        this.drivers = drivers;
        this.databaseName = databaseName;
        this.selectedDriver = selectedDriver;
        this.persistenceModelId = persistenceModelId;
        enabled = true;
        persistenceModelId = "";
    }

    public String getPersistenceModelId() {
        return persistenceModelId;
    }

    public void setPersistenceModelId(String persistenceModelId) {
        this.persistenceModelId = persistenceModelId;
    }

    public SimpleDBPersistenceModelConf() {
        enabled = false;
        drivers = new String[0];
    }

    public SimpleDBPersistenceModelConf(String host, String port, String databaseName, String username, String password, String[] drivers,
            int selectedDriver, boolean enabled, String persistenceModelId) {
        this(host, port, databaseName, username, password, drivers, selectedDriver, persistenceModelId);
        this.setEnabled(enabled);
        persistenceModelId = "";
    }

    /**
     * @return the host
     */
    public String getHost() {
        return host;
    }

    /**
     * @param host
     *            the host to set
     */
    public void setHost(String host) {
        this.host = host;
    }

    /**
     * @return the port
     */
    public String getPort() {
        return port;
    }

    /**
     * @param port
     *            the port to set
     */
    public void setPort(String port) {
        this.port = port;
    }

    /**
     * @return the username
     */
    public String getUsername() {
        return username;
    }

    /**
     * @param username
     *            the username to set
     */
    public void setUsername(String username) {
        this.username = username;
    }

    /**
     * @return the password
     */
    public String getPassword() {
        return password;
    }

    /**
     * @param password
     *            the password to set
     */
    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * @return the databaseName
     */
    public String getDatabaseName() {
        return databaseName;
    }

    /**
     * @param databaseName
     *            the databaseName to set
     */
    public void setDatabaseName(String databaseName) {
        this.databaseName = databaseName;
    }

    /**
     * @return the enabled
     */
    public boolean isEnabled() {
        return enabled;
    }

    /**
     * @param enabled
     *            the enabled to set
     */
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    /**
     * @return the selectedDriver
     */
    public int getSelectedDriver() {
        return selectedDriver;
    }

    /**
     * @param selectedDriver
     *            the selectedDriver to set
     */
    public void setSelectedDriver(int selectedDriver) {
        this.selectedDriver = selectedDriver;
    }

    /**
     * @return the drivers
     */
    public String[] getDrivers() {
        return drivers;
    }

    /**
     * @param drivers
     *            the drivers to set
     */
    public void setDrivers(String[] drivers) {
        this.drivers = drivers;
    }

    public String getDriver() {
        if( drivers == null || selectedDriver >= drivers.length) {
            return "";
        }
        return drivers[selectedDriver];
    }

    @Override
    public String toString() {
        return "enabled=" + enabled + ",host=" + host + ",port=" + port + ",username=" + username + ",selectedDriver=" + getDriver()
                + ",databaseName=" + databaseName;
    }

    public SimpleDBPersistenceModelConf createClone() {
        return new SimpleDBPersistenceModelConf(host, port, databaseName, username, password, drivers, selectedDriver, enabled,
                persistenceModelId);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((databaseName == null) ? 0 : databaseName.hashCode());
        result = prime * result + Arrays.hashCode(drivers);
        result = prime * result + (enabled ? 1231 : 1237);
        result = prime * result + ((host == null) ? 0 : host.hashCode());
        result = prime * result + ((password == null) ? 0 : password.hashCode());
        result = prime * result + ((persistenceModelId == null) ? 0 : persistenceModelId.hashCode());
        result = prime * result + ((port == null) ? 0 : port.hashCode());
        result = prime * result + selectedDriver;
        result = prime * result + ((username == null) ? 0 : username.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        SimpleDBPersistenceModelConf other = (SimpleDBPersistenceModelConf) obj;
        if (databaseName == null) {
            if (other.databaseName != null)
                return false;
        }
        else if (!databaseName.equals(other.databaseName))
            return false;
        if (!Arrays.equals(drivers, other.drivers))
            return false;
        if (enabled != other.enabled)
            return false;
        if (host == null) {
            if (other.host != null)
                return false;
        }
        else if (!host.equals(other.host))
            return false;
        if (password == null) {
            if (other.password != null)
                return false;
        }
        else if (!password.equals(other.password))
            return false;
        if (persistenceModelId == null) {
            if (other.persistenceModelId != null)
                return false;
        }
        else if (!persistenceModelId.equals(other.persistenceModelId))
            return false;
        if (port == null) {
            if (other.port != null)
                return false;
        }
        else if (!port.equals(other.port))
            return false;
        if (selectedDriver != other.selectedDriver)
            return false;
        if (username == null) {
            if (other.username != null)
                return false;
        }
        else if (!username.equals(other.username))
            return false;
        return true;
    }


}