package com.clcbio.client.thin.model.admin.configuration.system;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * @author jschultz A serializedble shadow of SqlDbParameters
 */
public class SqlPersistenceModelConf implements IsSerializable, ModelConfigurationAttributes {
    private boolean enabled;
    private String host;
    private String port;
    private String username;
    private String password;
    private int selectedDriver;
    private String databaseName;
    private String[] drivers;
    private String persistenceModelId;

    public SqlPersistenceModelConf(String host, String port, String databaseName, String username, String password, String[] drivers,
            int selectedDriver, String persistenceModelId) {
        this.host = host;
        this.port = port;
        this.username = username;
        this.password = password;
        this.drivers = drivers;
        this.databaseName = databaseName;
        this.selectedDriver = selectedDriver;
        this.persistenceModelId = persistenceModelId;
        enabled = true;
        persistenceModelId = "";
    }

    public String getPersistenceModelId() {
        return persistenceModelId;
    }

    public void setPersistenceModelId(String persistenceModelId) {
        this.persistenceModelId = persistenceModelId;
    }

    public SqlPersistenceModelConf() {
        enabled = false;
    }

    public SqlPersistenceModelConf(String host, String port, String databaseName, String username, String password, String[] drivers,
            int selectedDriver, boolean enabled, String persistenceModelId) {
        this(host, port, databaseName, username, password, drivers, selectedDriver, persistenceModelId);
        this.setEnabled(enabled);
        persistenceModelId = "";
    }

    /**
     * @return the host
     */
    public String getHost() {
        return host;
    }

    /**
     * @param host
     *            the host to set
     */
    public void setHost(String host) {
        this.host = host;
    }

    /**
     * @return the port
     */
    public String getPort() {
        return port;
    }

    /**
     * @param port
     *            the port to set
     */
    public void setPort(String port) {
        this.port = port;
    }

    /**
     * @return the username
     */
    public String getUsername() {
        return username;
    }

    /**
     * @param username
     *            the username to set
     */
    public void setUsername(String username) {
        this.username = username;
    }

    /**
     * @return the password
     */
    public String getPassword() {
        return password;
    }

    /**
     * @param password
     *            the password to set
     */
    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * @return the databaseName
     */
    public String getDatabaseName() {
        return databaseName;
    }

    /**
     * @param databaseName
     *            the databaseName to set
     */
    public void setDatabaseName(String databaseName) {
        this.databaseName = databaseName;
    }

    /**
     * @return the enabled
     */
    public boolean isEnabled() {
        return enabled;
    }

    /**
     * @param enabled
     *            the enabled to set
     */
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    /**
     * @return the selectedDriver
     */
    public int getSelectedDriver() {
        return selectedDriver;
    }

    /**
     * @param selectedDriver
     *            the selectedDriver to set
     */
    public void setSelectedDriver(int selectedDriver) {
        this.selectedDriver = selectedDriver;
    }

    /**
     * @return the drivers
     */
    public String[] getDrivers() {
        return drivers;
    }

    /**
     * @param drivers
     *            the drivers to set
     */
    public void setDrivers(String[] drivers) {
        this.drivers = drivers;
    }

    public String getDriver() {
        return drivers[selectedDriver];
    }

    @Override
    public String toString() {
        return "enabled=" + enabled + ",host=" + host + ",port=" + port + ",username=" + username + ",selectedDriver=" + getDriver()
                + ",databaseName=" + databaseName;
    }

    public SqlPersistenceModelConf createClone() {
        return new SqlPersistenceModelConf(host, port, databaseName, username, password, drivers, selectedDriver, enabled,
                persistenceModelId);
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof SqlPersistenceModelConf) {
            SqlPersistenceModelConf otherConf = (SqlPersistenceModelConf) obj;
            boolean same = true;
            same = same && this.getDatabaseName().equals(otherConf.getDatabaseName());
            same = same && this.getDriver().equals(otherConf.getDriver());
            same = same && this.getHost().equals(otherConf.getHost());
            same = same && this.getPassword().equals(otherConf.getPassword());
            same = same && this.getPort().equals(otherConf.getPort());
            same = same && this.getSelectedDriver() == otherConf.getSelectedDriver();
            same = same && this.isEnabled() == otherConf.isEnabled();
            same = same && this.getUsername().equals(otherConf.getUsername());
            same = same && this.getPersistenceModelId().equals(otherConf.getPersistenceModelId());
            return same;
        }
        else {
            return false;
        }
    }
}