package com.clcbio.client.thin.model.bugsubmission;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class DiagnosticsReport implements CommonBeanSerialization {
    private static final long serialVersionUID = 29550331895490213L;
    private DiagnosticsCheckType checkType;
    private boolean checkOk;
    private List<String> testResultDescriptionsHtml;

    public DiagnosticsReport(DiagnosticsCheckType checkType) {
        super();
        testResultDescriptionsHtml = new ArrayList<String>();
        this.checkType = checkType;
    }

    public DiagnosticsReport() {
        super();
    }

    public boolean isCheckOk() {
        return checkOk;
    }

    public void setCheckOk(boolean checkOk) {
        this.checkOk = checkOk;
    }

    public List<String> getTestResultDescriptionsHtml() {
        return testResultDescriptionsHtml;
    }

    public void setTestResultDescriptionsHtml(List<String> testResultDescriptionsHtml) {
        this.testResultDescriptionsHtml = testResultDescriptionsHtml;
    }

    public DiagnosticsCheckType getCheckType() {
        return checkType;
    }

    public void setCheckType(DiagnosticsCheckType checkType) {
        this.checkType = checkType;
    }

    @Override
    public String toString() {
        return "DiagnosticsReport [checkType=" + checkType + ", checkOk=" + checkOk + ", testResultDescriptionsHtml="
                + testResultDescriptionsHtml + "]";
    }
    
    public String toStringNice() {
        String stringRep = (isCheckOk()?"OK":"Error") + "\t" + getCheckType().getHeadline() + "\n\r";
        List<String> descs = getTestResultDescriptionsHtml();
        for (String string : descs) {
            stringRep = stringRep + "\t" + string + "\n\r";
        }
        stringRep = stringRep + "\n\r";
        return stringRep;
    }

}
