package com.clcbio.client.thin.model.clcurl;

import com.clcbio.client.thin.model.CommonBeanSerialization;

/**
 * A URL to a resource inside or outside of a CLC persistence model
 * 
 */
public class ClcUrlParameter implements CommonBeanSerialization {
    private static final long serialVersionUID = -7959257864177968426L;
    private String resourceName;
    private String clcUrl;
    private String clcShortUrl;
    
    public ClcUrlParameter() {
        super();
    }
    
    public ClcUrlParameter(String resourceName, String clcUrl) {
        super();
        this.resourceName = resourceName;
        this.clcUrl = clcUrl;
    }
    
    public ClcUrlParameter(String resourceName, String clcUrl, String clcShortUrl) {
        super();
        this.resourceName = resourceName;
        this.clcUrl = clcUrl;
        this.clcShortUrl = clcShortUrl;
    }
    
    public String getResourceName() {
        return resourceName;
    }
    
    public void setResourceName(String resourceName) {
        this.resourceName = resourceName;
    }
    
    public String getClcUrl() {
        return clcUrl;
    }
    
    public void setClcUrl(String clcUrl) {
        this.clcUrl = clcUrl;
    }
    
    public String getClcShortUrl() {
        return clcShortUrl;
    }
    
    public void setClcShortUrl(String clcShortUrl) {
        this.clcShortUrl = clcShortUrl;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((clcUrl == null) ? 0 : clcUrl.hashCode());
        result = prime * result + ((resourceName == null) ? 0 : resourceName.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ClcUrlParameter other = (ClcUrlParameter) obj;
        if (clcUrl == null) {
            if (other.clcUrl != null)
                return false;
        }
        else if (!clcUrl.equals(other.clcUrl))
            return false;
        if (resourceName == null) {
            if (other.resourceName != null)
                return false;
        }
        else if (!resourceName.equals(other.resourceName))
            return false;
        return true;
    }
    
    @Override
    public String toString() {
        return "resourceName=" + resourceName + ", clcUrl=" + clcUrl;
    }
    
    /*
     * Would have used clone, but this is not allowed in GWT serialized objects
     */
    public ClcUrlParameter clone4log() {
        ClcUrlParameter clone = new ClcUrlParameter();
        clone.setClcUrl(getClcUrl());
        clone.setResourceName(getResourceName());
        return clone;
    }
    
    public boolean isEmpty() {
        return clcUrl == null || clcUrl.isEmpty();
    }
}
