package com.clcbio.client.thin.model.command;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class NotificationPreferences implements CommonBeanSerialization{
    private List<String> recipientEmailAddresses;
    private boolean notifyOnSuccess;
    private boolean notifyOnFailure;
    
    public NotificationPreferences() {
        super();
        recipientEmailAddresses = new ArrayList<String>();
        notifyOnSuccess = true;
        notifyOnFailure = true;
    }

    public NotificationPreferences(NotificationPreferences cloneSource) {
        super();
        if(cloneSource.getRecipientEmailAddresses() != null){
            this.recipientEmailAddresses = new ArrayList<String>(cloneSource.getRecipientEmailAddresses());
        }
        else{
            this.recipientEmailAddresses = new ArrayList<String>();            
        }
        notifyOnSuccess = cloneSource.isNotifyOnSuccess();
        notifyOnFailure = cloneSource.isNotifyOnFailure();
    }

    private static final long serialVersionUID = -773394839923249051L;
    
    public List<String> getRecipientEmailAddresses() {
        return recipientEmailAddresses;
    }

    public void setRecipientEmailAddresses(List<String> recipientEmailAddresses) {
        this.recipientEmailAddresses = recipientEmailAddresses;
    }

    public NotificationPreferences clone4log() {
        return new NotificationPreferences(this);
    }

    public boolean isNotifyOnSuccess() {
        return notifyOnSuccess;
    }

    public void setNotifyOnSuccess(boolean notifyOnSuccess) {
        this.notifyOnSuccess = notifyOnSuccess;
    }

    public boolean isNotifyOnFailure() {
        return notifyOnFailure;
    }

    public void setNotifyOnFailure(boolean notifyOnFailure) {
        this.notifyOnFailure = notifyOnFailure;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (notifyOnFailure ? 1231 : 1237);
        result = prime * result + (notifyOnSuccess ? 1231 : 1237);
        result = prime * result + ((recipientEmailAddresses == null) ? 0 : recipientEmailAddresses.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        NotificationPreferences other = (NotificationPreferences) obj;
        if (notifyOnFailure != other.notifyOnFailure)
            return false;
        if (notifyOnSuccess != other.notifyOnSuccess)
            return false;
        if (recipientEmailAddresses == null) {
            if (other.recipientEmailAddresses != null)
                return false;
        }
        else if (!recipientEmailAddresses.equals(other.recipientEmailAddresses))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "NotificationPreferences [recipientEmailAddresses=" + recipientEmailAddresses + ", notifyOnSuccess=" + notifyOnSuccess
                + ", notifyOnFailure=" + notifyOnFailure + "]";
    }
    
}
