package com.clcbio.client.thin.model.command;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.processes.ClcProcessReflection;
import com.google.gwt.user.client.rpc.IsSerializable;

@SuppressWarnings("rawtypes")
public class ServerCommandOutput implements IsSerializable {

    private List outpuObjects;
    private ClcProcessReflection processStatus;

    public ServerCommandOutput() {
        super();
        outpuObjects = new ArrayList();
        processStatus = null;
    }
    @SuppressWarnings("unchecked")
    public ServerCommandOutput(ServerCommandOutput cloneFrom) {
        super();
        outpuObjects = new ArrayList();
        List sourceList = cloneFrom.getOutpuObjects();
        if (sourceList != null) {
            outpuObjects = new ArrayList(sourceList);
        }
        ClcProcessReflection ps = cloneFrom.getProcessStatus();
        if (ps != null) {
            processStatus = new ClcProcessReflection(ps);
        }
    }

    public ClcProcessReflection getProcessStatus() {
        return processStatus;
    }
    public void setProcessStatus(ClcProcessReflection processStatus) {
        this.processStatus = processStatus;
    }
    public List getOutpuObjects() {
        return outpuObjects;
    }

    public void setOutpuObjects(List outpuObjects) {
        this.outpuObjects = outpuObjects;
    }

    /*
     * Return a clone with reasonable values for logging
     */
    public ServerCommandOutput clone4log() {
        return new ServerCommandOutput(this);
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((outpuObjects == null) ? 0 : outpuObjects.hashCode());
        result = prime * result + ((processStatus == null) ? 0 : processStatus.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerCommandOutput other = (ServerCommandOutput) obj;
        if (outpuObjects == null) {
            if (other.outpuObjects != null)
                return false;
        }
        else if (!outpuObjects.equals(other.outpuObjects))
            return false;
        if (processStatus == null) {
            if (other.processStatus != null)
                return false;
        }
        else if (!processStatus.equals(other.processStatus))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "ServerCommandOutput [outpuObjects=" + outpuObjects + ", processStatus=" + processStatus + "]";
    }
}
