package com.clcbio.client.thin.model.command.algo;

import com.google.gwt.user.client.rpc.IsSerializable;

public class AlgoOutputPosting implements IsSerializable {
    private String posting;
    private AlgoReference algoReference;
    private long timestampMilis;

    public AlgoOutputPosting(AlgoOutputPosting cloneSource) {
        posting = cloneSource.getPosting();
        algoReference = cloneSource.getAlgoReference().clone4log();
        timestampMilis = cloneSource.getTimestampMilis();
    }

    public AlgoOutputPosting() {
        super();
        posting = "";
        algoReference = new AlgoReference();
        timestampMilis = 0;
    }

    public String getPosting() {
        return posting;
    }

    public void setPosting(String posting) {
        this.posting = posting;
    }

    public AlgoReference getAlgoReference() {
        return algoReference;
    }

    public void setAlgoReference(AlgoReference algoReference) {
        this.algoReference = algoReference;
    }

    @Override
    public String toString() {
        return algoReference + ":" + posting;
    }

    public long getTimestampMilis() {
        return timestampMilis;
    }

    public void setTimestampMilis(long timestamp) {
        this.timestampMilis = timestamp;
    }

    public AlgoOutputPosting gwtClone() {
        AlgoOutputPosting clone = new AlgoOutputPosting();
        AlgoReference algoRefClone = null;
        if (algoReference != null) {
            algoRefClone = algoReference.gwtClone();
        }
        clone.setAlgoReference(algoRefClone);
        clone.setPosting(posting);
        clone.setTimestampMilis(timestampMilis);
        return clone;
    }

    public AlgoOutputPosting clone4log() {
        return new AlgoOutputPosting(this);
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((algoReference == null) ? 0 : algoReference.hashCode());
        result = prime * result + ((posting == null) ? 0 : posting.hashCode());
        result = prime * result + (int) (timestampMilis ^ (timestampMilis >>> 32));
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        AlgoOutputPosting other = (AlgoOutputPosting) obj;
        if (algoReference == null) {
            if (other.algoReference != null)
                return false;
        }
        else if (!algoReference.equals(other.algoReference))
            return false;
        if (posting == null) {
            if (other.posting != null)
                return false;
        }
        else if (!posting.equals(other.posting))
            return false;
        if (timestampMilis != other.timestampMilis)
            return false;
        return true;
    }
    
}
