package com.clcbio.client.thin.model.command.algo;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class ServerAlgoChannel implements CommonBeanSerialization {
    private static final long serialVersionUID = 5870223951665989225L;
    
    private String name;
    private String description;
    private String outputType;
    private String classKey;
    
    public ServerAlgoChannel() {
        super();
        name = "";
        description = "";
        outputType = "";
        classKey = "";
    }
    public ServerAlgoChannel(ServerAlgoChannel cloneSource) {
        name = cloneSource.getName();
        description = cloneSource.getDescription();
        outputType = cloneSource.getOutputType();
        classKey = cloneSource.classKey;        
    }
    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }
    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }
    public String getOutputType() {
        return outputType;
    }
    public void setOutputType(String outputType) {
        this.outputType = outputType;
    }
    public String getClassKey() {
        return classKey;
    }
    public void setClassKey(String classKey) {
        this.classKey = classKey;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((classKey == null) ? 0 : classKey.hashCode());
        result = prime * result + ((description == null) ? 0 : description.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((outputType == null) ? 0 : outputType.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerAlgoChannel other = (ServerAlgoChannel) obj;
        if (classKey == null) {
            if (other.classKey != null)
                return false;
        }
        else if (!classKey.equals(other.classKey))
            return false;
        if (description == null) {
            if (other.description != null)
                return false;
        }
        else if (!description.equals(other.description))
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        }
        else if (!name.equals(other.name))
            return false;
        if (outputType == null) {
            if (other.outputType != null)
                return false;
        }
        else if (!outputType.equals(other.outputType))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "ServerAlgoChannel [name=" + name + ", description=" + description + ", outputType=" + outputType + ", classKey="
                + classKey + "]";
    }
    public ServerAlgoChannel clone4log() {
        return new ServerAlgoChannel(this);
    }
    
  }
