package com.clcbio.client.thin.model.command.algo;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;

public class ServerAlgoChannelInput extends ServerAlgoChannel{
    private static final long serialVersionUID = -5232820290987042680L;
    private List<ClcUrlParameter> channelInputObjectReferences;
    
    public ServerAlgoChannelInput() {
        super();
        channelInputObjectReferences = new ArrayList<ClcUrlParameter>();
    }
    public ServerAlgoChannelInput(ServerAlgoChannelInput cloneSource) {
        super(cloneSource);
        channelInputObjectReferences = new ArrayList<ClcUrlParameter>();
        List<ClcUrlParameter> sourceList = cloneSource.getChannelInputObjectReferences();
        if(sourceList != null){
            for (ClcUrlParameter source : sourceList) {
                channelInputObjectReferences.add(source.clone4log());
            }            
        }
    }
    public List<ClcUrlParameter> getChannelInputObjectReferences() {
        return channelInputObjectReferences;
    }
    public void setChannelInputObjectReferences(List<ClcUrlParameter> channelInputObjectReferences) {
        this.channelInputObjectReferences = channelInputObjectReferences;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((channelInputObjectReferences == null) ? 0 : channelInputObjectReferences.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerAlgoChannelInput other = (ServerAlgoChannelInput) obj;
        if (channelInputObjectReferences == null) {
            if (other.channelInputObjectReferences != null)
                return false;
        }
        else if (!channelInputObjectReferences.equals(other.channelInputObjectReferences))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "ServerAlgoChannelInput [channelInputObjectReferences=" + channelInputObjectReferences + ", getName()=" + getName()
                + ", getDescription()=" + getDescription() + ", getOutputType()=" + getOutputType() + ", getClassKey()="
                + getClassKey() + "]";
    }
    @Override
    public ServerAlgoChannelInput clone4log() {
        return new ServerAlgoChannelInput(this);
    }

}
