package com.clcbio.client.thin.model.command.algo;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;

public class ServerAlgoChannelOutput extends ServerAlgoChannel{
    private static final long serialVersionUID = 2157591372056271570L;
    private List<ClcUrlParameter> channelOutputObjectReferences;
    
    public ServerAlgoChannelOutput() {
        super();
        channelOutputObjectReferences = new ArrayList<ClcUrlParameter>();
    }
    public ServerAlgoChannelOutput(ServerAlgoChannelOutput cloneSource) {
        super(cloneSource);
        channelOutputObjectReferences = new ArrayList<ClcUrlParameter>();
        List<ClcUrlParameter> sourceList = cloneSource.getChannelOutputObjectReferences();
        if(sourceList != null){
            for (ClcUrlParameter source : sourceList) {
                channelOutputObjectReferences.add(source.clone4log());
            }            
        }
    }

    public List<ClcUrlParameter> getChannelOutputObjectReferences() {
        return channelOutputObjectReferences;
    }
    public void setChannelOutputObjectReferences(List<ClcUrlParameter> channelOutputObjectReferences) {
        this.channelOutputObjectReferences = channelOutputObjectReferences;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((channelOutputObjectReferences == null) ? 0 : channelOutputObjectReferences.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerAlgoChannelOutput other = (ServerAlgoChannelOutput) obj;
        if (channelOutputObjectReferences == null) {
            if (other.channelOutputObjectReferences != null)
                return false;
        }
        else if (!channelOutputObjectReferences.equals(other.channelOutputObjectReferences))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "ServerAlgoChannelOutput [channelOutputObjectReferences=" + channelOutputObjectReferences + ", getName()=" + getName()
                + ", getDescription()=" + getDescription() + ", getOutputType()=" + getOutputType() + ", getClassKey()="
                + getClassKey() + "]";
    }
    @Override
    public ServerAlgoChannelOutput clone4log() {
        return new ServerAlgoChannelOutput(this);
    }

}
