package com.clcbio.client.thin.model.command.algo;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;

public class ServerAlgoDestination implements CommonBeanSerialization{
    private static final long serialVersionUID = 7940431471949703854L;
    private ClcUrlParameter destination;
    private ServerAlgoChannel channel;
    
    public ServerAlgoDestination() {
        super();
        destination = new ClcUrlParameter();
        channel = new ServerAlgoChannel();
    }
    public ServerAlgoDestination(ServerAlgoDestination cloneSource) {
        destination = cloneSource.getDestination().clone4log();
        channel = cloneSource.getChannel().clone4log();
    }
    public ClcUrlParameter getDestination() {
        return destination;
    }
    public void setDestination(ClcUrlParameter destination) {
        this.destination = destination;
    }
    public ServerAlgoChannel getChannel() {
        return channel;
    }
    public void setChannel(ServerAlgoChannel channel) {
        this.channel = channel;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((channel == null) ? 0 : channel.hashCode());
        result = prime * result + ((destination == null) ? 0 : destination.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerAlgoDestination other = (ServerAlgoDestination) obj;
        if (channel == null) {
            if (other.channel != null)
                return false;
        }
        else if (!channel.equals(other.channel))
            return false;
        if (destination == null) {
            if (other.destination != null)
                return false;
        }
        else if (!destination.equals(other.destination))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "ServerAlgoDestination [destination=" + destination + ", channel=" + channel + "]";
    }
    public ServerAlgoDestination clone4log() {
        return new ServerAlgoDestination(this);
    }
    
}
