package com.clcbio.client.thin.model.command.algo;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.ServerCommandOutput;

public class ServerCommandAlgoOutput extends ServerCommandOutput {
    private List<ServerAlgoChannelOutput> serverAlgoOutputChannels;
    private List<AlgoOutputPosting> messages;
    private ClcUrlParameter logObjRef;
    public ServerCommandAlgoOutput() {
        super();
        serverAlgoOutputChannels = new ArrayList<ServerAlgoChannelOutput>();
        messages = new ArrayList<AlgoOutputPosting>();
    }
    public ServerCommandAlgoOutput(ServerCommandAlgoOutput cloneFrom) {
        super(cloneFrom);
        serverAlgoOutputChannels = new ArrayList<ServerAlgoChannelOutput>();
        messages = new ArrayList<AlgoOutputPosting>();
        List<AlgoOutputPosting> msgSource = cloneFrom.getMessages();
        if(msgSource != null){
            for (AlgoOutputPosting algoOutputPosting : msgSource) {
                messages.add(algoOutputPosting.clone4log());
            }            
        }
        List<ServerAlgoChannelOutput> chlSources = cloneFrom.getServerAlgoOutputChannels();
        if(chlSources != null){
            for (ServerAlgoChannelOutput chlSource : chlSources) {
                serverAlgoOutputChannels.add(chlSource.clone4log());
            }            
        }
        ClcUrlParameter logSource = cloneFrom.getLogObjRef();
        logObjRef = logSource == null?null:logSource.clone4log();
    }
    public List<ServerAlgoChannelOutput> getServerAlgoOutputChannels() {
        return serverAlgoOutputChannels;
    }
    public void setServerAlgoOutputChannels(List<ServerAlgoChannelOutput> serverAlgoOutputChannels) {
        this.serverAlgoOutputChannels = serverAlgoOutputChannels;
    }
    public List<AlgoOutputPosting> getMessages() {
        return messages;
    }
    public void setMessages(List<AlgoOutputPosting> messages) {
        this.messages = messages;
    }
    public ClcUrlParameter getLogObjRef() {
        return logObjRef;
    }
    public void setLogObjRef(ClcUrlParameter logObjRef) {
        this.logObjRef = logObjRef;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((logObjRef == null) ? 0 : logObjRef.hashCode());
        result = prime * result + ((messages == null) ? 0 : messages.hashCode());
        result = prime * result + ((serverAlgoOutputChannels == null) ? 0 : serverAlgoOutputChannels.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerCommandAlgoOutput other = (ServerCommandAlgoOutput) obj;
        if (logObjRef == null) {
            if (other.logObjRef != null)
                return false;
        }
        else if (!logObjRef.equals(other.logObjRef))
            return false;
        if (messages == null) {
            if (other.messages != null)
                return false;
        }
        else if (!messages.equals(other.messages))
            return false;
        if (serverAlgoOutputChannels == null) {
            if (other.serverAlgoOutputChannels != null)
                return false;
        }
        else if (!serverAlgoOutputChannels.equals(other.serverAlgoOutputChannels))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "ServerCommandAlgoOutput [serverAlgoOutputChannels=" + serverAlgoOutputChannels + ", messages=" + messages
                + ", logObjRef=" + logObjRef + ", toString()=" + super.toString() + "]";
    }
    @Override
    public ServerCommandOutput clone4log() {
        return new ServerCommandAlgoOutput(this);
    }
    

}
