package com.clcbio.client.thin.model.command.algo;

import com.clcbio.client.thin.model.command.ServerCommandReference;

public class ServerCommandAlgoReference extends ServerCommandReference {
    private boolean noInputAlgo;

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + (noInputAlgo ? 1231 : 1237);
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerCommandAlgoReference other = (ServerCommandAlgoReference) obj;
        if (noInputAlgo != other.noInputAlgo)
            return false;
        return true;
    }

    public ServerCommandAlgoReference() {
        super();
    }

    public ServerCommandAlgoReference(ServerCommandAlgoReference cloneFrom) {
        super(cloneFrom);
        setNoInputAlgo(cloneFrom.isNoInputAlgo());
    }
    public boolean isNoInputAlgo() {
        return noInputAlgo;
    }

    public void setNoInputAlgo(boolean noInputAlgo) {
        this.noInputAlgo = noInputAlgo;
    }

    @Override
    public String toString() {
        return "ServerCommandAlgoReference [noInputAlgo=" + noInputAlgo + ", getId()=" + getId() + ", getName()=" + getName()
                + ", getCommandParameters()=" + getCommandParameters() + ", getCommandOutputType()=" + getCommandOutputType()
                + ", getVersion()=" + getVersion() + ", isMasterCommand()=" + isMasterCommand() + "]";
    }

    @Override
    public ServerCommandReference clone4log() {
        return new ServerCommandAlgoReference(this);
    }

}
