package com.clcbio.client.thin.model.command.algo.parameter;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeBoolean;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeByte;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeDouble;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeInteger;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeLong;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeString;

public class AlgoParameterValueType implements CommonBeanSerialization {
    private static final long serialVersionUID = 8921379952356417706L;
    private String fullClassName;
    
    public AlgoParameterValueType() {
        super();
    }
    
    public AlgoParameterValueType(String fullClassName) {
        this.fullClassName = fullClassName;
    }
    
    public String getFullClassName() {
        return fullClassName;
    }
    
    public void setFullClassName(String fullClassName) {
        this.fullClassName = fullClassName;
    }
    
    public static AlgoParameterValueType createFromName(String name) {
        AlgoParameterValueType knownJavaSubTypes[] = { new ValueTypeBoolean(), new ValueTypeByte(), new ValueTypeDouble(),
                new ValueTypeInteger(), new ValueTypeLong(), new ValueTypeString() };
        for (int i = 0; i < knownJavaSubTypes.length; i++) {
            String className = knownJavaSubTypes[i].getFullClassName();
            if (className.equals(name)) {
                return knownJavaSubTypes[i];
            }
        }
        return null;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((fullClassName == null) ? 0 : fullClassName.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        AlgoParameterValueType other = (AlgoParameterValueType) obj;
        if (fullClassName == null) {
            if (other.fullClassName != null)
                return false;
        }
        else if (!fullClassName.equals(other.fullClassName))
            return false;
        return true;
    }
    
    @Override
    public String toString() {
        return "AlgoParameterValueType [fullClassName=" + fullClassName + "]";
    }
    
}
