package com.clcbio.client.thin.model.command.algo.parameter.type;

import com.clcbio.client.thin.model.command.algo.parameter.AlgoParameterValueType;

public class ValueTypeDouble extends AlgoParameterValueType {
    private static final long serialVersionUID = -1634991192016318727L;
    private Double min;
    private Double max;
    private boolean minInclusive;
    private boolean maxInclusive;
    
    /**
     * Calling this will call {@link #ValueTypeDouble(Double.MIN_VALUE, Double.MAX_VALUE, true, true)}
     */
    public ValueTypeDouble() {
        this(Double.MIN_VALUE, Double.MAX_VALUE, true, true);
    }
    
    /**
     * Passing null as min parameter will be converted to MIN_VALUE and max as null to MAX_VALUE
     * 
     * @param min
     * @param max
     * @param minInclusive
     * @param maxInclusive
     */
    public ValueTypeDouble(Double min, Double max, boolean minInclusive, boolean maxInclusive) {
        super(Double.class.getName());
        if (min == null) {
            this.min = Double.MIN_VALUE;
        }
        else {
            this.min = min;
        }
        if (max == null) {
            this.max = Double.MAX_VALUE;
        }
        else {
            this.max = max;
        }
        this.minInclusive = minInclusive;
        this.maxInclusive = maxInclusive;
    }
    
    public Double getMin() {
        return min;
    }
    
    public void setMin(Double min) {
        this.min = min;
    }
    
    public Double getMax() {
        return max;
    }
    
    public void setMax(Double max) {
        this.max = max;
    }
    
    public boolean isMinInclusive() {
        return minInclusive;
    }
    
    public void setMinInclusive(boolean minInclusive) {
        this.minInclusive = minInclusive;
    }
    
    public boolean isMaxInclusive() {
        return maxInclusive;
    }
    
    public void setMaxInclusive(boolean maxInclusive) {
        this.maxInclusive = maxInclusive;
    }
    
}
