package com.clcbio.client.thin.model.command.algo.parameter.type;

import com.clcbio.client.thin.model.command.algo.parameter.AlgoParameterValueType;

public class ValueTypeLong extends AlgoParameterValueType {
    private static final long serialVersionUID = -1737499190406827123L;
    private Long min;
    private Long max;
    
    /**
     * Calling this passes {@link Long}'s MIN_VALUE and MAX_VALUE as min and max parameters to {@link #ValueTypeLong(Long, Long)}
     */
    public ValueTypeLong() {
        this(Long.MIN_VALUE, Long.MAX_VALUE);
    }
    
    /**
     * Passing null as min parameter will be converted to MIN_VALUE and max as null to MAX_VALUE
     * 
     * @param min
     * @param max
     */
    public ValueTypeLong(Long min, Long max) {
        super(Long.class.getName());
        if (min == null) {
            this.min = Long.MIN_VALUE;
        }
        else {
            this.min = min;
        }
        if (max == null) {
            this.max = Long.MAX_VALUE;
        }
        else {
            this.max = max;
        }
    }
    
    public Long getMin() {
        return min;
    }
    
    public void setMin(Long min) {
        this.min = min;
    }
    
    public Long getMax() {
        return max;
    }
    
    public void setMax(Long max) {
        this.max = max;
    }
    
}
