package com.clcbio.client.thin.model.command.algo.parameter.validation;

import java.util.ArrayList;
import java.util.Collection;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class AlgoParameterValidationBeans implements CommonBeanSerialization {
    private static final long serialVersionUID = -3324931507091744044L;
    private Collection<AlgoParameterValidationBean> validations;
    
    public AlgoParameterValidationBeans() {
        super();
        validations = new ArrayList<AlgoParameterValidationBean>();
    }
    
    public Collection<AlgoParameterValidationBean> getValidations() {
        return validations;
    }
    
    public void setValidations(Collection<AlgoParameterValidationBean> validations) {
        this.validations = validations;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((validations == null) ? 0 : validations.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        AlgoParameterValidationBeans other = (AlgoParameterValidationBeans) obj;
        if (validations == null) {
            if (other.validations != null)
                return false;
        }
        else if (!validations.equals(other.validations))
            return false;
        return true;
    }
    
    @Override
    public String toString() {
        return "AlgoParameterValidationBeans [validations=" + validations + "]";
    }
    
    public boolean hasValidationType(ParameterValidationType... validationType) {
        for (AlgoParameterValidationBean algoParameterValidationBean : getValidations()) {
            for (int i = 0; i < validationType.length; i++) {
                if(algoParameterValidationBean.getValidationType().equals(validationType[i])){
                    return true;
                }                
            }
        };
        return false;
    }

}
