package com.clcbio.client.thin.model.command.clexe;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import com.clcbio.client.thin.model.ThinBinaryData;
import com.clcbio.client.thin.model.command.ServerCommandOutput;
import com.clcbio.client.thin.model.command.clexe.types.TypeImportCommandInput;
import com.google.gwt.user.client.rpc.IsSerializable;

public class CommandLineExecuterOutput extends ServerCommandOutput implements IsSerializable {
    private int exitValue;
    private ThinBinaryData standardOut;
    private ThinBinaryData standardError;
    private String substitutedCommandLine;
    private Map<TypeImportCommandInput, ThinBinaryData> outputFiles;

    public CommandLineExecuterOutput() {
        super();
        exitValue = -1;
        standardOut = new ThinBinaryData();
        standardError = new ThinBinaryData();
        outputFiles = new HashMap<TypeImportCommandInput, ThinBinaryData>();
        substitutedCommandLine = "";
    }

    @Override
    public String toString() {
        return super.toString() + ",exitValue=" + exitValue + ",standardOut=" + standardOut + ",standardError=" + standardError
                + ",outputFiles=" + outputFiles + ",substitutedCommandLine=" + substitutedCommandLine;
    }

    public int getExitValue() {
        return exitValue;
    }

    public void setExitValue(int exitValue) {
        this.exitValue = exitValue;
    }

    public ThinBinaryData getStandardOut() {
        return standardOut;
    }

    public void setStandardOut(ThinBinaryData standardOut) {
        this.standardOut = standardOut;
    }

    public ThinBinaryData getStandardError() {
        return standardError;
    }

    public Map<TypeImportCommandInput, ThinBinaryData> getOutputFiles() {
        return outputFiles;
    }

    public void setOutputFiles(Map<TypeImportCommandInput, ThinBinaryData> outputFiles) {
        this.outputFiles = outputFiles;
    }

    public void setStandardError(ThinBinaryData standardError) {
        this.standardError = standardError;
    }

    public String getSubstitutedCommandLine() {
        return substitutedCommandLine;
    }

    public void setSubstitutedCommandLine(String substitutedCommandLine) {
        this.substitutedCommandLine = substitutedCommandLine;
    }

    @Override
    public ServerCommandOutput clone4log() {
        CommandLineExecuterOutput clone = new CommandLineExecuterOutput();
        ServerCommandOutput superClone = super.clone4log();
        clone.setExitValue(this.getExitValue());
        // this will prevent logging of the actual binary data
        clone.setStandardOut(new ThinBinaryData(this.getStandardOut()));
        clone.setStandardError(new ThinBinaryData(this.getStandardError()));
        clone.setOutputFiles(createThins(this.getOutputFiles()));
        clone.setSubstitutedCommandLine(getSubstitutedCommandLine());
        clone.setOutpuObjects(superClone.getOutpuObjects());
        return clone;
    }

    private Map<TypeImportCommandInput, ThinBinaryData> createThins(Map<TypeImportCommandInput, ThinBinaryData> outputFiles2) {
        HashMap<TypeImportCommandInput, ThinBinaryData> res = new HashMap<TypeImportCommandInput, ThinBinaryData>();
        Set<Entry<TypeImportCommandInput, ThinBinaryData>> entries = outputFiles2.entrySet();
        for (Iterator iterator = entries.iterator(); iterator.hasNext();) {
            Entry<TypeImportCommandInput, ThinBinaryData> entry = (Entry<TypeImportCommandInput, ThinBinaryData>) iterator.next();
            // this will prevent logging of the actual binary data
            res.put(entry.getKey(), new ThinBinaryData(entry.getValue()));
        }
        return res;
    }

    @Override
    public boolean equals(Object obj) {
        // let tostring decide
        return this.toString().equals(obj.toString());
    }

}
