package com.clcbio.client.thin.model.command.clexe.master;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.command.clexe.CommandLineExecuterParameters;
import com.google.gwt.user.client.rpc.IsSerializable;

public class CommandLineExecuterMasterParameters extends ServerCommandParameters implements IsSerializable {
    private static final long serialVersionUID = -1940285296847419709L;
    private CommandLineExecuterParameters commandLineExecuterParameters;
    private String commandLineExecuterCommandId;
    private String commandLineExecuterCommandName;
    private ClcUrlParameter commandLineOutputInsertionPoint;

    public CommandLineExecuterMasterParameters() {
        super();
        commandLineExecuterParameters = new CommandLineExecuterParameters();
        init();
    }

    public CommandLineExecuterMasterParameters(ServerCommandParameters commandParameters) {
        super(commandParameters);
        commandLineExecuterParameters = new CommandLineExecuterParameters(commandParameters);
        init();
    }

    private void init() {
        commandLineExecuterCommandId = "";
        commandLineExecuterCommandName = "";
    }

    @Override
    public String toString() {
        return super.toString() + ",commandLineExecuterCommandId=" + commandLineExecuterCommandId + ",commandLineExecuterCommandName="
                + commandLineExecuterCommandName + ",commandLineExecuterParameters=" + commandLineExecuterParameters
                + ",insertionPoint=" + commandLineOutputInsertionPoint;
    }

    public String getCommandLineExecuterCommandName() {
        return commandLineExecuterCommandName;
    }

    public void setCommandLineExecuterCommandName(String commandLineExecuterCommandName) {
        this.commandLineExecuterCommandName = commandLineExecuterCommandName;
    }

    public CommandLineExecuterParameters getCommandLineExecuterParameters() {
        return commandLineExecuterParameters;
    }

    public void setCommandLineExecuterParameters(CommandLineExecuterParameters commandLineExecuterParameters) {
        this.commandLineExecuterParameters = commandLineExecuterParameters;
    }

    public ClcUrlParameter getCommandLineOutputInsertionPoint() {
        return commandLineOutputInsertionPoint;
    }

    public void setCommandLineOutputInsertionPoint(ClcUrlParameter commandLineOutputInsertionPoint) {
        this.commandLineOutputInsertionPoint = commandLineOutputInsertionPoint;
    }

    public String getCommandLineExecuterCommandId() {
        return commandLineExecuterCommandId;
    }

    public void setCommandLineExecuterCommandId(String commandLineExecuterCommandId) {
        this.commandLineExecuterCommandId = commandLineExecuterCommandId;
    }

    @Override
    public CommandLineExecuterMasterParameters clone4log() {
        CommandLineExecuterMasterParameters clone = new CommandLineExecuterMasterParameters(super.clone4log());
        clone.setCommandLineExecuterParameters(getCommandLineExecuterParameters().clone4log());
        clone.setCommandLineOutputInsertionPoint(getCommandLineOutputInsertionPoint());

        clone.setCommandLineExecuterCommandId(getCommandLineExecuterCommandId());
        clone.setCommandLineExecuterCommandName(getCommandLineExecuterCommandName());
        return clone;
    }
}
