package com.clcbio.client.thin.model.command.clexe.postproc;

import java.util.Map.Entry;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.algo.parameter.AlgoParameterBean;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrlObject;

/**
 * This Object represents the intrinsic input objects that all Algos take that
 * is not part of the algo parameters map. Used in conjunction with mapping
 * External Application Parameters to algo parameters.
 * 
 */
public class PostProcessAlgoInputObjectParam implements Entry<String, AlgoParameterBean>, CommonBeanSerialization {
    private static final long serialVersionUID = 8354880923029544784L;
    public static String KEY = "Input data (common for all algorithms)";
    AlgoParameterBean val;

    public PostProcessAlgoInputObjectParam() {
        super();
        val = new AlgoParameterBean();
        val.setShortDescription(KEY);
        val.setLongDescription(KEY);
        val.setValueType(new ValueTypeClcUrlObject());
    }

    public String getKey() {
        return KEY;
    }

    public AlgoParameterBean getValue() {
        return val;
    }

    public AlgoParameterBean setValue(AlgoParameterBean value) {
        val = value;
        return val;
    }
}
