package com.clcbio.client.thin.model.command.clexe.types;

import com.google.gwt.user.client.rpc.IsSerializable;

public enum UserArgumentType implements IsSerializable {
    TYPE_BINARY_OBJECT(), TYPE_BOOLEAN(), TYPE_COMMAND_OUTPUT(), TYPE_EXPORT_COMMAND_OUTPUT(), TYPE_STRING(), TYPE_IMPORT_COMMAND_INPUT(), TYPE_CSV_ENUM(), TYPE_BOOLEAN_COMPOUND(), TYPE_DOUBLE(), TYPE_CONTEXT_SUBSTITUTE(), TYPE_INTEGER(), TYPE_SAFE_FILE();

    public UserClArg createUserClArg() {
        if (this.equals(TYPE_BINARY_OBJECT)) {
            return new TypeBinaryObject();
        }
        else if (this.equals(TYPE_BOOLEAN)) {
            return new TypeBoolean();
        }
        else if (this.equals(TYPE_COMMAND_OUTPUT)) {
            return new TypeCommandOutput();
        }
        else if (this.equals(TYPE_EXPORT_COMMAND_OUTPUT)) {
            return new TypeExportCommandOutput();
        }
        else if (this.equals(TYPE_STRING)) {
            return new TypeString();
        }
        else if (this.equals(TYPE_IMPORT_COMMAND_INPUT)) {
            return new TypeImportCommandInput();
        }
        else if (this.equals(TYPE_CSV_ENUM)) {
            return new TypeCsvEnum();
        }
        else if (this.equals(TYPE_BOOLEAN_COMPOUND)) {
            return new TypeBooleanCompound();
        }
        else if (this.equals(TYPE_DOUBLE)) {
            return new TypeDouble();
        }
        else if (this.equals(TYPE_CONTEXT_SUBSTITUTE)) {
            return new TypeContextSubstitute();
        }
        else if (this.equals(TYPE_INTEGER)) {
            return new TypeInteger();
        }
        else if (this.equals(TYPE_SAFE_FILE)) {
            return new TypeSafeFile();
        }
        return null;
    }
}
