package com.clcbio.client.thin.model.command.direct;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.ServerCommandOutput;
import com.clcbio.client.thin.model.exceptions.ThinException;
import com.clcbio.client.thin.model.serialization.SerializedBeanXML;

public class DirectCommandOutput extends ServerCommandOutput implements CommonBeanSerialization  {
    private static final long serialVersionUID = 4001797459164720481L;
    private SerializedBeanXML methodReturnValue;
    private ThinException methodException;
    
    public DirectCommandOutput() {
        super();
    }
    
    public SerializedBeanXML getMethodReturnValue() {
        return methodReturnValue;
    }

    public void setMethodReturnValue(SerializedBeanXML methodReturnValue) {
        this.methodReturnValue = methodReturnValue;
    }

    public ThinException getMethodException() {
        return methodException;
    }

    public void setMethodException(ThinException methodException) {
        this.methodException = methodException;
    }
    @Override
    public ServerCommandOutput clone4log() {
        DirectCommandOutput clone = new DirectCommandOutput();
        clone.setMethodException(getMethodException());
        clone.setMethodReturnValue(getMethodReturnValue().clone4log());
        return clone;
    }

    @Override
    public String toString() {
        return "DirectCommandOutput [methodReturnValue=" + methodReturnValue + ", methodException=" + methodException + "]";
    }
    
}
