package com.clcbio.client.thin.model.command.direct;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class DirectCommandParametersAttribute implements CommonBeanSerialization {
 
    private static final long serialVersionUID = 9077268988864229320L;
    private String path;
    private String mapping;
    private String help;
    
    public DirectCommandParametersAttribute() {
        super();
    }
 
    public DirectCommandParametersAttribute(DirectCommandParametersAttribute other) {
        super();
        
        path = other.path;
        mapping = other.mapping;
        help = other.help;
    }
    
    public String getPath() {
        return path;
    }
    
    public void setPath(String path) {
        this.path = path;
    }
    
    public String getMapping() {
        return mapping;
    }
    
    public void setMapping(String mapping) {
        this.mapping = mapping;
    }
    
    public String getHelp() {
        return help;
    }
    
    public void setHelp(String help) {
        this.help = help;
    }

    public DirectCommandParametersAttribute clone4log() {
        return new DirectCommandParametersAttribute(this);
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((help == null) ? 0 : help.hashCode());
        result = prime * result + ((mapping == null) ? 0 : mapping.hashCode());
        result = prime * result + ((path == null) ? 0 : path.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        DirectCommandParametersAttribute other = (DirectCommandParametersAttribute) obj;
        if (help == null) {
            if (other.help != null)
                return false;
        }
        else if (!help.equals(other.help))
            return false;
        if (mapping == null) {
            if (other.mapping != null)
                return false;
        }
        else if (!mapping.equals(other.mapping))
            return false;
        if (path == null) {
            if (other.path != null)
                return false;
        }
        else if (!path.equals(other.path))
            return false;
        return true;
    }
    
}
