package com.clcbio.client.thin.model.command.direct;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.ServerCommandOutput;
import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.command.ServerCommandReference;

public class DirectCommandReference extends ServerCommandReference implements CommonBeanSerialization {
    private static final long serialVersionUID = 521596385065817679L;
    private String description;
    private String cltName;
    
    public DirectCommandReference() {
        super();
        setCommandOutputType(new DirectCommandOutput());
        setCommandParameters(new DirectCommandParameters());
        description = "";
        cltName = "";
    }

    public DirectCommandReference(DirectCommandReference directCommandReference) {
        super(directCommandReference);
    }

    public void setCommandParameters(ServerCommandParameters commandParameters) {
        if( !(commandParameters instanceof DirectCommandParameters) ) {
            throw new ClassCastException("commandParameters is not an instance of DirectCommandParameters");
        }
        super.setCommandParameters(commandParameters);
    }

    public void setCommandOutputType(ServerCommandOutput commandOutputType) {
        if( !(commandOutputType instanceof DirectCommandOutput) ) {
            throw new ClassCastException("commandOutputType is not an instance of DirectCommandOutputType");
        }
        super.setCommandOutputType(commandOutputType);
    }

    @Override
    public ServerCommandReference clone4log() {
        return new DirectCommandReference(this);
    }

    public void setDescription(String str) {
        description = str;
    }
    
    public String getDescription() {
        return description;
    }
    
    public void setCLTName(String cltName) {
        this.cltName = cltName;
    }
    
    public String getCLTName() {
        return cltName;
    }
}
