package com.clcbio.client.thin.model.command.exporter;

import com.clcbio.client.thin.model.command.ServerCommandOutput;
import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.command.ServerCommandReference;

public class ServerExportCommandReference extends ServerCommandReference {

    public ServerExportCommandReference() {
        super();
        setCommandOutputType(new ServerExporterOutput());
        setCommandParameters(new ServerExporterParameters());
    }

    public void setCommandParameters(ServerCommandParameters commandParameters) {
        if( !(commandParameters instanceof ServerExporterParameters) ) {
            throw new ClassCastException("commandParameters is not an instance of ServerExporterParameters");
        }
        super.setCommandParameters(commandParameters);
    }
    
    public void setCommandOutputType(ServerCommandOutput commandOutputType) {
        if( !(commandOutputType instanceof ServerExporterOutput) ) {
            throw new ClassCastException("commandOutputType is not an instance of ServerExporterOutput");
        }
        super.setCommandOutputType(commandOutputType);
    }
}
