package com.clcbio.client.thin.model.command.exporter;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.ServerCommandParameters;

public class ServerExporterParameters extends ServerCommandParameters {
    private static final long serialVersionUID = 5880547714942582959L;
    private List<ClcUrlParameter> objectsToExport;
    private String exportPluginClassKey;
    private ClcUrlParameter overridingExportDestinationDir;

    public ServerExporterParameters() {
        super();
        init();
    }

    public ServerExporterParameters(ServerCommandParameters commandParameters) {
        super(commandParameters);
        init();
    }

    private void init() {
        objectsToExport = new ArrayList<ClcUrlParameter>();
        exportPluginClassKey = "";
        overridingExportDestinationDir = new ClcUrlParameter();
    }

    @Override
    public String toString() {
        String string = "objectToExport=" + objectsToExport.toString() + ",exportPluginClassKey=" + exportPluginClassKey
                + ",exportDestinationDir=" + overridingExportDestinationDir;
        return super.toString() + "," + string;
    }

    public String getExportPluginClassKey() {
        return exportPluginClassKey;
    }

    public void setExportPluginClassKey(String importPluginClassKey) {
        this.exportPluginClassKey = importPluginClassKey;
    }

    public List<ClcUrlParameter> getObjectsToExport() {
        return objectsToExport;
    }

    public void setObjectsToExport(List<ClcUrlParameter> objectToExport) {
        this.objectsToExport = objectToExport;
    }

    public ClcUrlParameter getOverridingExportDestinationDir() {
        return overridingExportDestinationDir;
    }

    public void setOverridingExportDestinationDir(ClcUrlParameter overridingExportDestinationDir) {
        this.overridingExportDestinationDir = overridingExportDestinationDir;
    }

    @Override
    public ServerExporterParameters clone4log() {
        ServerExporterParameters clone = new ServerExporterParameters(super.clone4log());
        clone.setExportPluginClassKey(getExportPluginClassKey());
        ArrayList<ClcUrlParameter> c = new ArrayList<ClcUrlParameter>();
        c.addAll(getObjectsToExport());
        clone.setObjectsToExport(c);
        clone.setOverridingExportDestinationDir(overridingExportDestinationDir.clone4log());
        return clone;
    }

}
