package com.clcbio.client.thin.model.command.grid;

import com.clcbio.client.thin.model.admin.configuration.subsystem.grid.GridPreset;
import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.command.ServerCommandReference;

public class GridExecuterParameters extends ServerCommandParameters {
    private static final long serialVersionUID = -2226035725883352314L;
    private ServerCommandReference gridExcutedCommand;
    private GridPreset gridPreset;

    public GridExecuterParameters() {
        super();
        init();
    }

    public GridExecuterParameters(ServerCommandParameters commandParameters) {
        super(commandParameters);
        init();
    }

    private void init() {
        gridExcutedCommand = new ServerCommandReference();
        gridPreset = new GridPreset();
    }

    public GridPreset getGridPreset() {
        return gridPreset;
    }

    public void setGridPreset(GridPreset gridPreset) {
        this.gridPreset = gridPreset;
    }

    public ServerCommandReference getGridExcutedCommand() {
        return gridExcutedCommand;
    }

    public void setGridExcutedCommand(ServerCommandReference gridExcutedCommand) {
        this.gridExcutedCommand = gridExcutedCommand;
    }

    @Override
    public String toString() {
        String string = "gridPreset= " + gridPreset + ", gridExcutedCommand=" + gridExcutedCommand.toString();
        return super.toString() + "," + string;
    }

    @Override
    public GridExecuterParameters clone4log() {
        GridExecuterParameters clone = new GridExecuterParameters(super.clone4log());
        clone.setGridExcutedCommand(getGridExcutedCommand().clone4log());
        clone.setGridPreset(getGridPreset().createClone());
        return clone;
    }

}
