package com.clcbio.client.thin.model.command.importer;

import com.clcbio.client.thin.model.command.ServerCommandOutput;
import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.command.ServerCommandReference;
import com.clcbio.client.thin.model.command.direct.DirectCommandParameters;

public class ServerImportCommandReference extends ServerCommandReference {

    public ServerImportCommandReference() {
        super();
        setCommandOutputType(new ServerImporterOutput());
        setCommandParameters(new ServerImporterParameters());
    }

    public void setCommandParameters(ServerCommandParameters commandParameters) {
        if( !(commandParameters instanceof ServerCommandParameters) ) {
            throw new ClassCastException("commandParameters is not an instance of ServerCommandParameters");
        }
        super.setCommandParameters(commandParameters);
    }

    public void setCommandOutputType(ServerCommandOutput commandOutputType) {
        if( !(commandOutputType instanceof ServerImporterOutput) ) {
            throw new ClassCastException("commandOutputType is not an instance of ServerImporterOutput");
        }
        super.setCommandOutputType(commandOutputType);
    }
}
