package com.clcbio.client.thin.model.command.importer;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.command.clexe.types.TypeImportCommandInput;

public class ServerImporterParameters extends ServerCommandParameters {

    private static final long serialVersionUID = 1L;
    private ClcUrlParameter insertionPoint;
    private String importPluginClassKey;
    private List<ClcUrlParameter> filesToImport;
    private TypeImportCommandInput inputFromTerminatedProcess;

    public ServerImporterParameters() {
        super();
        init();
    }

    public ServerImporterParameters(ServerCommandParameters commandParameters) {
        super(commandParameters);
        init();
    }

    private void init() {
        insertionPoint = new ClcUrlParameter();
        importPluginClassKey = "";
        filesToImport = new ArrayList<ClcUrlParameter>();
        inputFromTerminatedProcess = null;
    }

    @Override
    public String toString() {
        String string = "importPosition=" + insertionPoint.toString() + ",filesToImport=" + filesToImport.toString()
                + ",importPluginClassKey=" + importPluginClassKey;
        if (inputFromTerminatedProcess != null) {
            string = string + ",inputFromTerminatedProcess=" + inputFromTerminatedProcess;
        }
        return super.toString() + "," + string;
    }

    public TypeImportCommandInput getInputFromTerminatedProcess() {
        return inputFromTerminatedProcess;
    }

    public void setInputFromTerminatedProcess(TypeImportCommandInput inputFromTerminatedProcess) {
        this.inputFromTerminatedProcess = inputFromTerminatedProcess;
    }

    public String getImportPluginClassKey() {
        return importPluginClassKey;
    }

    public void setImportPluginClassKey(String importPluginClassKey) {
        this.importPluginClassKey = importPluginClassKey;
    }

    public List<ClcUrlParameter> getFilesToImport() {
        return filesToImport;
    }

    public void setFilesToImport(List<ClcUrlParameter> filesToImport) {
        this.filesToImport = filesToImport;
    }

    public ClcUrlParameter getInsertionPoint() {
        return insertionPoint;
    }

    public void setInsertionPoint(ClcUrlParameter insertionPoint) {
        this.insertionPoint = insertionPoint;
    }

    @Override
    public ServerImporterParameters clone4log() {
        ServerImporterParameters clone = new ServerImporterParameters(super.clone4log());
        clone.setImportPluginClassKey(getImportPluginClassKey());
        clone.setInsertionPoint(getInsertionPoint());
        clone.setFilesToImport(clone(getFilesToImport()));
        clone.setInputFromTerminatedProcess(getInputFromTerminatedProcess());
        return clone;
    }

    private List<ClcUrlParameter> clone(List<ClcUrlParameter> filesToImport2) {
        List<ClcUrlParameter> res = new ArrayList<ClcUrlParameter>(filesToImport2.size());
        for (ClcUrlParameter clcUrlParameter : filesToImport2) {
            res.add(clcUrlParameter.clone4log());
        }
        return res;
    }

}
