package com.clcbio.client.thin.model.command.maintenance;

import java.util.ArrayList;

import com.clcbio.client.thin.model.command.ServerCommandOutput;

public class RemoveTerminatedProcessesOutput extends ServerCommandOutput {
    private ArrayList<String> removedProcessDescriptions;

    public RemoveTerminatedProcessesOutput() {
        super();
        removedProcessDescriptions = new ArrayList<String>();
    }

    @Override
    public String toString() {
        return super.toString() + removedProcessDescriptions.toString();
    }

    @Override
    public ServerCommandOutput clone4log() {
        RemoveTerminatedProcessesOutput clone = new RemoveTerminatedProcessesOutput();
        ServerCommandOutput superClone = super.clone4log();
        clone.setOutpuObjects(superClone.getOutpuObjects());
        clone.setRemovedProcessDescriptions(this.getRemovedProcessDescriptions());
        return clone;
    }

    public ArrayList<String> getRemovedProcessDescriptions() {
        return removedProcessDescriptions;
    }

    public void setRemovedProcessDescriptions(ArrayList<String> removedProcessDescriptions) {
        this.removedProcessDescriptions = removedProcessDescriptions;
    }

}
