package com.clcbio.client.thin.model.command.maintenance;

import com.clcbio.client.thin.model.command.ServerCommandParameters;
import com.clcbio.client.thin.model.schedule.ThinDate;

public class RemoveTerminatedProcessesParameters extends ServerCommandParameters {

    private static final long serialVersionUID = 1L;
    private ThinDate preservationDate;
    private boolean invokeOnAllUsers;

    public RemoveTerminatedProcessesParameters() {
        super();
        init();
    }

    public RemoveTerminatedProcessesParameters(ServerCommandParameters commandParameters) {
        super(commandParameters);
        init();
    }

    private void init() {
        preservationDate = new ThinDate();
        invokeOnAllUsers = false;
    }

    @Override
    public String toString() {
        String string = "preservationDate=" + preservationDate + ",allUsersTerminatedProcesses=" + invokeOnAllUsers;
        return super.toString() + "," + string;
    }

    @Override
    public RemoveTerminatedProcessesParameters clone4log() {
        RemoveTerminatedProcessesParameters clone = new RemoveTerminatedProcessesParameters(super.clone4log());
        clone.setPreservationDate(getPreservationDate());
        clone.setInvokeOnAllUsers(isInvokeOnAllUsers());
        return clone;
    }

    public ThinDate getPreservationDate() {
        return preservationDate;
    }

    public void setPreservationDate(ThinDate preservationDate) {
        this.preservationDate = preservationDate;
    }

    public boolean isInvokeOnAllUsers() {
        return invokeOnAllUsers;
    }

    public void setInvokeOnAllUsers(boolean invokeOnAllUsers) {
        this.invokeOnAllUsers = invokeOnAllUsers;
    }

}
