package com.clcbio.client.thin.model.command.master;

import java.util.ArrayList;
import java.util.List;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.ServerCommandOutput;

public class MasterCommandOutput extends ServerCommandOutput implements CommonBeanSerialization {
    private static final long serialVersionUID = 8586845174173415891L;
    private List<ServerCommandOutput> childProcessesOutput;
    public MasterCommandOutput() {
        super();
        childProcessesOutput = null;
    }
    
    public MasterCommandOutput(MasterCommandOutput cloneFrom) {
        super(cloneFrom);
        List<ServerCommandOutput> sourceList = cloneFrom.getChildProcessesOutput();
        if(sourceList == null){
            childProcessesOutput = null;
        }
        else{
            childProcessesOutput = new ArrayList<ServerCommandOutput>();
            for (ServerCommandOutput source : sourceList) {
                childProcessesOutput.add(source.clone4log());
            }            
        }
    }

    public List<ServerCommandOutput> getChildProcessesOutput() {
        return childProcessesOutput;
    }


    public void setChildProcessesOutput(List<ServerCommandOutput> childProcessesOutput) {
        this.childProcessesOutput = childProcessesOutput;
    }


    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((childProcessesOutput == null) ? 0 : childProcessesOutput.hashCode());
        return result;
    }


    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        MasterCommandOutput other = (MasterCommandOutput) obj;
        if (childProcessesOutput == null) {
            if (other.childProcessesOutput != null)
                return false;
        }
        else if (!childProcessesOutput.equals(other.childProcessesOutput))
            return false;
        return true;
    }


    @Override
    public String toString() {
        return "DefaultMasterOutput [childProcessesOutput=" + childProcessesOutput + ", toString()=" + super.toString() + "]";
    }


    @Override
    public MasterCommandOutput clone4log() {
        return new MasterCommandOutput(this);
    }

}
