package com.clcbio.client.thin.model.command.workflow;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.master.MasterCommandOutput;
import com.google.gwt.user.client.rpc.IsSerializable;

public class WorkflowCommandOutput extends MasterCommandOutput implements IsSerializable {
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((workflowLog == null) ? 0 : workflowLog.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        WorkflowCommandOutput other = (WorkflowCommandOutput) obj;
        if (workflowLog == null) {
            if (other.workflowLog != null)
                return false;
        }
        else if (!workflowLog.equals(other.workflowLog))
            return false;
        return true;
    }

    private static final long serialVersionUID = 4607084564320304134L;
    private ClcUrlParameter workflowLog;

    public WorkflowCommandOutput() {
        super();
        workflowLog = new ClcUrlParameter();
    }
    
    public WorkflowCommandOutput(WorkflowCommandOutput cloneFrom) {
        super(cloneFrom);
        ClcUrlParameter log = cloneFrom.getWorkflowLog();
        if (log != null) {
            workflowLog = log.clone4log();
        }
        else {
            workflowLog = new ClcUrlParameter();
        }
    }
        
    public ClcUrlParameter getWorkflowLog() {
        return workflowLog;
    }
    
    public void setWorkflowLog(ClcUrlParameter workflowLog) {
        this.workflowLog = workflowLog;
    }

    @Override
    public String toString() {
        return "WorkflowCommandOutput [workflowLog=" + workflowLog + ", toString()=" + super.toString() + "]";
    }
    
}
