package com.clcbio.client.thin.model.constrain;

import java.util.HashSet;
import java.util.Set;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class ClcObjectTypeConstraint implements CommonBeanSerialization {
    private static final long serialVersionUID = 7179189985404314155L;
    private String allowedObjectClassName;
    private Set<String> allowedSubtypeNames;
    
    public ClcObjectTypeConstraint() {
        super();
        allowedObjectClassName = "";
        allowedSubtypeNames = new HashSet<String>();
    }
    
    public String getAllowedObjectClassName() {
        return allowedObjectClassName;
    }
    
    public void setAllowedObjectClassName(String allowedObjectClassName) {
        this.allowedObjectClassName = allowedObjectClassName;
    }
    
    public Set<String> getAllowedSubtypeNames() {
        return allowedSubtypeNames;
    }
    
    public void setAllowedSubtypeNames(Set<String> allowedSubtypeNames) {
        this.allowedSubtypeNames = allowedSubtypeNames;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((allowedObjectClassName == null) ? 0 : allowedObjectClassName.hashCode());
        result = prime * result + ((allowedSubtypeNames == null) ? 0 : allowedSubtypeNames.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ClcObjectTypeConstraint other = (ClcObjectTypeConstraint) obj;
        if (allowedObjectClassName == null) {
            if (other.allowedObjectClassName != null)
                return false;
        }
        else if (!allowedObjectClassName.equals(other.allowedObjectClassName))
            return false;
        if (allowedSubtypeNames == null) {
            if (other.allowedSubtypeNames != null)
                return false;
        }
        else if (!allowedSubtypeNames.equals(other.allowedSubtypeNames))
            return false;
        return true;
    }
    
    @Override
    public String toString() {
        return "ClcObjectTypeConstraint [allowedObjectClassName=" + allowedObjectClassName + ", allowedSubtypeNames="
                + allowedSubtypeNames + "]";
    }
    
}
