package com.clcbio.client.thin.model.exceptions;

import java.util.List;

public class DeserializedException extends Throwable{
    
    private static final long serialVersionUID = 260754730295668509L;

    public DeserializedException() {
        super();
    }

    public DeserializedException(String message, Throwable cause) {
        super(message, cause);
    }
    public DeserializedException(ThinException cause) {
        super(cause.getMessage());
        StackTraceElement[] deserializedStackTrace = deserializeStackTrace(cause.getStacktrace());
        if (deserializedStackTrace != null) {
            setStackTrace(deserializedStackTrace);
        }
    }

    public DeserializedException(String message) {
        super(message);
    }

    public DeserializedException(Throwable cause) {
        super(cause);
    }

    private StackTraceElement[] deserializeStackTrace(List<SerializeableStackTraceElement> serializedStacktrace) {
        if (serializedStacktrace == null) {
            return null;
        }
        else {
            StackTraceElement[] result = new StackTraceElement[serializedStacktrace.size()];
            int i = 0;
            for (SerializeableStackTraceElement serializeableStackTraceElement : serializedStacktrace) {
                StackTraceElement ste = new StackTraceElement(
                        serializeableStackTraceElement.getDeclaringClass(),
                        serializeableStackTraceElement.getMethodName(),
                        serializeableStackTraceElement.getFileName(),
                        serializeableStackTraceElement.getLineNumber());
                result[i] = ste;
                i++;
            }
            return result;
        }
    }
}
