package com.clcbio.client.thin.model.exceptions;

import java.util.List;

import com.clcbio.client.thin.helper.ThinExceptionHelper;
import com.clcbio.client.thin.model.CommonBeanSerialization;

public class ThinException implements CommonBeanSerialization {
    private static final long serialVersionUID = 4159060481804768635L;
    private String message;
    private String exceptionClassName;
    private List<SerializeableStackTraceElement> stacktrace;

    public ThinException(Throwable cause) {
        ThinExceptionHelper.fromThickToThin(this, cause);
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public ThinException() {
        super();
    }

    public List<SerializeableStackTraceElement> getStacktrace() {
        return stacktrace;
    }

    public void setStacktrace(List<SerializeableStackTraceElement> stacktrace) {
        this.stacktrace = stacktrace;
    }

    @Override
    public String toString() {
        // TODO Auto-generated method stub
        return getMessage() + getStacktrace();
    }

    public String getExceptionClassName() {
        return exceptionClassName;
    }

    public void setExceptionClassName(String exceptionClassName) {
        this.exceptionClassName = exceptionClassName;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((exceptionClassName == null) ? 0 : exceptionClassName.hashCode());
        result = prime * result + ((message == null) ? 0 : message.hashCode());
        result = prime * result + ((stacktrace == null) ? 0 : stacktrace.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ThinException other = (ThinException) obj;
        if (exceptionClassName == null) {
            if (other.exceptionClassName != null)
                return false;
        }
        else if (!exceptionClassName.equals(other.exceptionClassName))
            return false;
        if (message == null) {
            if (other.message != null)
                return false;
        }
        else if (!message.equals(other.message))
            return false;
        if (stacktrace == null) {
            if (other.stacktrace != null)
                return false;
        }
        else if (!stacktrace.equals(other.stacktrace))
            return false;
        return true;
    }

}
