package com.clcbio.client.thin.model.executionenvironment;

import com.clcbio.client.thin.model.admin.configuration.subsystem.grid.GridPreset;

public class ServerGridExecutionEnvironment extends ServerExecutionEnvironment{
    private static final long serialVersionUID = 7018386330681284008L;
    private GridPreset gridPreset;
    
    public ServerGridExecutionEnvironment() {
        super();
    }

    public ServerGridExecutionEnvironment(GridPreset gridPreset) {
        super();
        this.gridPreset = gridPreset;
    }

    public GridPreset getGridPreset() {
        return gridPreset;
    }

    public void setGridPreset(GridPreset gridPreset) {
        this.gridPreset = gridPreset;
    }

    public ServerGridExecutionEnvironment clone4log() {
        return new ServerGridExecutionEnvironment(gridPreset.createClone());
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((gridPreset == null) ? 0 : gridPreset.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerGridExecutionEnvironment other = (ServerGridExecutionEnvironment) obj;
        if (gridPreset == null) {
            if (other.gridPreset != null)
                return false;
        }
        else if (!gridPreset.equals(other.gridPreset))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "GridExecutionEnvironment [gridPreset=" + gridPreset + "]";
    }
    
}
