package com.clcbio.client.thin.model.importexport;

import com.google.gwt.user.client.rpc.IsSerializable;

public class ExportPluginReference implements IsSerializable, Comparable {
    public static String EXTERNAL_FILE_FILTER_DESCRIPTION = "External File";
    public static String EXTERNAL_FILE_PLUGIN_CLASS_KEY = "externalfile";

    private String exportPluginClassKey;
    private String fileFilterDescription;

    /**
     * @param importPluginClassKey
     * @param fileFilterDescription
     */
    public ExportPluginReference(String exportPluginClassKey, String fileFilterDescription) {
        super();
        setExportPluginClassKey(exportPluginClassKey);
        setFileFilterDescription(fileFilterDescription);
    }

    public ExportPluginReference() {
        super();
    }

    public String getExportPluginClassKey() {
        return exportPluginClassKey;
    }

    public void setExportPluginClassKey(String exportPluginClassKey) {
        this.exportPluginClassKey = exportPluginClassKey;
    }

    public String getFileFilterDescription() {
        return fileFilterDescription;
    }

    public void setFileFilterDescription(String fileFilterDescription) {
        this.fileFilterDescription = fileFilterDescription;
    }

    public int compareTo(Object otherObject) {
        return getFileFilterDescription().compareTo(((ExportPluginReference) otherObject).getFileFilterDescription());
    }

    public static ExportPluginReference createExternalFile() {
        ExportPluginReference forcedFormat = new ExportPluginReference();
        forcedFormat.setFileFilterDescription(EXTERNAL_FILE_FILTER_DESCRIPTION);
        forcedFormat.setExportPluginClassKey(EXTERNAL_FILE_PLUGIN_CLASS_KEY);
        return forcedFormat;
    }

}
