package com.clcbio.client.thin.model.importexport;

import com.google.gwt.user.client.rpc.IsSerializable;

public class ImportPluginReference implements IsSerializable, Comparable {
    public static String AUTO_SNIFFER_FILE_FILTER_DESCRIPTION = "Automatic";
    public static String AUTO_SNIFFER_PLUGIN_CLASS_KEY = "automaticimport";
    public static String EXTERNAL_FILE_FILTER_DESCRIPTION = "External File";
    public static String EXTERNAL_FILE_PLUGIN_CLASS_KEY = "externalfile";

    private String importPluginClassKey;
    private String fileFilterDescription;

    public static ImportPluginReference createAutoSnifferElement() {
        ImportPluginReference autoFormat = new ImportPluginReference();
        autoFormat.setFileFilterDescription(ImportPluginReference.AUTO_SNIFFER_FILE_FILTER_DESCRIPTION);
        autoFormat.setImportPluginClassKey(ImportPluginReference.AUTO_SNIFFER_PLUGIN_CLASS_KEY);
        return autoFormat;
    }

    public static ImportPluginReference createExternalFile() {
        ImportPluginReference forcedFormat = new ImportPluginReference();
        forcedFormat.setFileFilterDescription(ImportPluginReference.EXTERNAL_FILE_FILTER_DESCRIPTION);
        forcedFormat.setImportPluginClassKey(ImportPluginReference.EXTERNAL_FILE_PLUGIN_CLASS_KEY);
        return forcedFormat;
    }

    /**
     * @param importPluginClassKey
     * @param fileFilterDescription
     */
    public ImportPluginReference(String importPluginClassKey, String fileFilterDescription) {
        super();
        setImportPluginClassKey(importPluginClassKey);
        setFileFilterDescription(fileFilterDescription);
    }

    public ImportPluginReference() {
        super();
    }

    /**
     * @return the importPluginClassKey
     */
    public String getImportPluginClassKey() {
        return importPluginClassKey;
    }

    /**
     * @param importPluginClassKey
     *            the importPluginClassKey to set
     */
    public void setImportPluginClassKey(String importPluginClassKey) {
        this.importPluginClassKey = importPluginClassKey;
    }

    /**
     * @return the fileFilterDescription
     */
    public String getFileFilterDescription() {
        return fileFilterDescription;
    }

    /**
     * @param fileFilterDescription
     *            the fileFilterDescription to set
     */
    public void setFileFilterDescription(String fileFilterDescription) {
        this.fileFilterDescription = fileFilterDescription;
    }

    public int compareTo(Object otherObject) {
        return getFileFilterDescription().compareTo(((ImportPluginReference) otherObject).getFileFilterDescription());
    }

}
