package com.clcbio.client.thin.model.legacy;

import com.clcbio.client.thin.model.CLCObjectReference;
import com.clcbio.client.thin.model.ThinBinaryData;

/**
 * A thin client reference to a corresponding Model File Object
 * 
 */
public class CLCFileObjectReference extends CLCObjectReference {
    private ThinBinaryData binaryData;

    public CLCFileObjectReference() {
        super();
        binaryData = new ThinBinaryData();
    }

    public CLCFileObjectReference(CLCFileObjectReference cloneFrom) {
        super(cloneFrom);
        binaryData = cloneFrom.getBinaryData().clone4log();
    }

    public ThinBinaryData getBinaryData() {
        return binaryData;
    }

    public void setBinaryData(ThinBinaryData binaryData) {
        this.binaryData = binaryData;
    }

    @Override
    public CLCObjectReference clone4log() {
        return new CLCFileObjectReference(this);
    }

    @Override
    public String toString() {
        return "CLCFileObjectReference [binaryData=" + binaryData + "]";
    }

}
