package com.clcbio.client.thin.model.log;

import com.google.gwt.user.client.rpc.IsSerializable;

public enum LogDBField implements IsSerializable {
    level(1, " integer NOT NULL", false), logger(64, " varchar(64) NOT NULL", false), message(255, " varchar(255) NOT NULL", false), sourceClass(64, " varchar(64) NOT NULL", false), sourceMethod(32, " varchar(32) NOT NULL",
            false), threadName(255, " varchar(255) NOT NULL", false), timeEntered(1, " datetime NOT NULL", false), username(255,
            " varchar(255) NOT NULL", false), sessionID(255, " varchar(255) NOT NULL", false), iPAddress(255,
            " varchar(255) NOT NULL", false), dataIn(-1, " longvarbinary", true), dataOut(-1, " longvarbinary", true), serverProcessId(
            255, " varchar(255) NOT NULL", false);

    public int length;
    private String createStr;
    public boolean columnSizeAutoAdjustment;

    public String createString() {
        return name() + createStr;
    }

    /**
     * @param length
     *            length of field interpreted by mapping mechanism and used for
     *            auto column update
     * @param createString
     *            the SQL create string
     * @param columnSizeAutoAdjustment
     *            if field length in connected DB should be adjusted to size
     *            given by length
     */
    private LogDBField(int length, String createString, boolean columnSizeAutoAdjustment) {
        this.length = length;
        this.createStr = createString;
        this.columnSizeAutoAdjustment = columnSizeAutoAdjustment;
    }

}
