package com.clcbio.client.thin.model.log;

import java.util.Arrays;
import java.util.List;

import com.google.gwt.user.client.rpc.IsSerializable;

public class LogDBTable implements IsSerializable {
    private static String tableNameSuffix = "";
    private static String name = "CLCServerAuditLog";

    public static final List<LogDBField> FIELDS = Arrays.asList( LogDBField.level, LogDBField.logger, LogDBField.message,
            LogDBField.sourceClass, LogDBField.sourceMethod, LogDBField.threadName, LogDBField.timeEntered, LogDBField.username,
            LogDBField.sessionID, LogDBField.iPAddress, LogDBField.dataIn, LogDBField.dataOut, LogDBField.serverProcessId );

    public static String FieldsToCSV() {
        String csv = "";
        for (int i = 0; i < FIELDS.size(); i++) {
            csv += "," + FIELDS.get(i).name();
        }
        return csv.replaceFirst(",", "");
    }

    public static void setTableNameSuffix(String newTableNameSuffix) {
        tableNameSuffix = newTableNameSuffix;
    }

    public static String getTableNameSuffix() {
        return tableNameSuffix;
    }

    public static String getCreateSql(String tablePrefix) {
        String createFields = "";
        for (int i = 0; i < FIELDS.size(); i++) {
            createFields += ", " + FIELDS.get(i).createString();
        }
        createFields = createFields.replaceFirst(",", "");
        return "CREATE " + tablePrefix + " TABLE " + getTableName() + " (" + createFields + ")";
    }

    public static String getAlterColumnSql(LogDBField dbField) {
        return "ALTER TABLE " + getTableName() + " ALTER COLUMN " + dbField.createString();
    }

    public static String getInsertSQL() {
        return "insert into " + getTableName() + " (" + FieldsToCSV() + ")" + "values(?,?,?,?,?,?,?,?,?,?,?,?,?)";
    }

    public static String getClearSQL() {
        return "delete from " + getTableName() + ";";
    }

    public static String getTableName() {
        return name + tableNameSuffix;
    }

}
