package com.clcbio.client.thin.model.log;

import java.util.List;

import com.clcbio.client.thin.model.log.Operations.OperationsLogged;
import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * The needed extra Fields that are not present in the LogRecord object (which
 * could not be extended and and used in a sensible way)
 */
public class LogEntry implements IsSerializable {
    
    private String IPAddress;
    private String username;
    private String sessionID;
    private String serverProcessId;
    private Long timeStamp;
    private OperationsLogged operation;
    private boolean exiting;
    private boolean entering;
    private List<Object> objectsIn;
    private List<Object> objectsOut;
    private String sourceClass;
    private String commandName;
    
    public String getIPAddress() {
        return IPAddress;
    }
    
    public void setIPAddress(String address) {
        IPAddress = address;
    }
    
    public String getUsername() {
        return username;
    }
    
    public void setUsername(String username) {
        this.username = username;
    }
    
    public String getSessionID() {
        return sessionID;
    }
    
    public void setSessionID(String sessionID) {
        this.sessionID = sessionID;
    }
    
    /**
     * 
     * @param iPAddress
     * @param username
     * @param sessionID
     * @param serverProcessId
     * @param objectsIn
     * @param objectsOut
     * @param operation sourceMethod
     * @param sourceClass
     */
    public LogEntry(String iPAddress, String username, String sessionID, String serverProcessId, List<Object> objectsIn,
            List<Object> objectsOut, OperationsLogged operation, String sourceClass) {
        super();
        IPAddress = iPAddress;
        this.username = username;
        this.sessionID = sessionID;
        this.objectsIn = objectsIn;
        this.objectsOut = objectsOut;
        this.serverProcessId = serverProcessId;
        this.operation = operation;
        this.sourceClass = sourceClass;
    }
    
    public Long getTimeStamp() {
        return timeStamp;
    }
    
    public void setTimeStamp(Long timeStamp) {
        this.timeStamp = timeStamp;
    }
    
    public OperationsLogged getOperation() {
        return operation;
    }
    
    public void setOperation(OperationsLogged operation) {
        this.operation = operation;
    }
    
    @Override
    public String toString() {
        return "IPAddress=" + IPAddress + ", username=" + username + ", objectsIn=" + objectsIn + ", objectsOut="
                + objectsOut + ", sessionID=" + sessionID + ", serverProcessId=" + serverProcessId + ", sourceClass="
                + sourceClass + ", operation=" + operation;
        
    }
    
    public LogEntry() {
        super();
    }
    
    public boolean isExiting() {
        return exiting;
    }
    
    public void setExiting(boolean exiting) {
        this.exiting = exiting;
    }
    
    public boolean isEntering() {
        return entering;
    }
    
    public void setEntering(boolean entering) {
        this.entering = entering;
    }
    
    public List<Object> getObjectsIn() {
        return objectsIn;
    }
    
    public void setObjectsIn(List<Object> javaBeanObjectsIn) {
        this.objectsIn = javaBeanObjectsIn;
    }
    
    public List<Object> getObjectsOut() {
        return objectsOut;
    }
    
    public void setObjectsOut(List<Object> javaBeanObjectsOut) {
        this.objectsOut = javaBeanObjectsOut;
    }
    
    public String getServerProcessId() {
        return serverProcessId;
    }
    
    public void setServerProcessId(String serverProcessId) {
        this.serverProcessId = serverProcessId;
    }
    
    public String getSourceClass() {
        return sourceClass;
    }
    
    public void setSourceClass(String sourceClass) {
        this.sourceClass = sourceClass;
    }

    public void setCommandName(String name) {
        this.commandName = name;
    }
    
    public String getCommandName() {
        return this.commandName;
    }
    
}
