package com.clcbio.client.thin.model.log;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * Adds and specifies fields to distinguish the query from the result
 * 
 */
public class LogQuery extends LogEntry implements IsSerializable {
    private Integer windowFrom;
    private Integer windowTo;
    private Long onOrAfterThisDate;
    private Long beforeThisDate;
    private SelectDestinctableFields destinctField;
    private List<String> processIds;

    public static enum SelectDestinctableFields implements IsSerializable {
        username(LogDBField.username.name());
        public String dBcolumnName;

        SelectDestinctableFields(String dBcolumnName) {
            this.dBcolumnName = dBcolumnName;
        }
    }

    public LogQuery() {
        super();
        windowFrom = 1;
        windowTo = 50;
        processIds = new ArrayList<String>();
    }

    public Integer getWindowFrom() {
        return windowFrom;
    }

    public void setWindowFrom(Integer windowFrom) {
        this.windowFrom = windowFrom;
    }

    public Integer getWindowTo() {
        return windowTo;
    }

    public void setWindowTo(Integer windowTo) {
        this.windowTo = windowTo;
    }

    public Long getOnOrAfterThisDate() {
        return onOrAfterThisDate;
    }

    public void setOnOrAfterThisDate(Long onOrBeforeDate) {
        this.onOrAfterThisDate = onOrBeforeDate;
    }

    public SelectDestinctableFields getDestinctField() {
        return destinctField;
    }

    public void setDestinctField(SelectDestinctableFields destinctField) {
        this.destinctField = destinctField;
    }

    public List<String> getProcessIds() {
        return processIds;
    }

    public void setProcessIds(List<String> processIds) {
        this.processIds = processIds;
    }

    public Long getBeforeThisDate() {
        return beforeThisDate;
    }

    public void setBeforeThisDate(Long beforeThisDate) {
        this.beforeThisDate = beforeThisDate;
    }

}
