package com.clcbio.client.thin.model.qualification;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.exceptions.ThinException;

public class QualificationReport implements CommonBeanSerialization{
    private static final long serialVersionUID = -5912351101488866418L;
    private QualificationClassification executionQualification;
    private ThinException qualificationEvaluationException;
    private String nonExecutionQualificationExplanation;
    private ServerCommandIdentifier qualifiedCommand;
    
    public QualificationReport() {
        super();
        qualificationEvaluationException = null;
        nonExecutionQualificationExplanation = "";
        executionQualification = QualificationClassification.LEVEL_00_DISQUALIFIED;
        qualifiedCommand = null;
    }
    public ThinException getQualificationEvaluationException() {
        return qualificationEvaluationException;
    }
    public void setQualificationEvaluationException(ThinException qualificationEvaluationException) {
        this.qualificationEvaluationException = qualificationEvaluationException;
    }
    public QualificationClassification getExecutionQualification() {
        return executionQualification;
    }
    public void setExecutionQualification(QualificationClassification executionQualification) {
        this.executionQualification = executionQualification;
    }
    public ServerCommandIdentifier getQualifiedCommand() {
        return qualifiedCommand;
    }
    public void setQualifiedCommand(ServerCommandIdentifier qualifiedCommand) {
        this.qualifiedCommand = qualifiedCommand;
    }
    public String getNonExecutionQualificationExplanation() {
        return nonExecutionQualificationExplanation;
    }
    public void setNonExecutionQualificationExplanation(String nonExecutionQualificationExplanation) {
        this.nonExecutionQualificationExplanation = nonExecutionQualificationExplanation;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((executionQualification == null) ? 0 : executionQualification.hashCode());
        result = prime * result
                + ((nonExecutionQualificationExplanation == null) ? 0 : nonExecutionQualificationExplanation.hashCode());
        result = prime * result + ((qualificationEvaluationException == null) ? 0 : qualificationEvaluationException.hashCode());
        result = prime * result + ((qualifiedCommand == null) ? 0 : qualifiedCommand.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        QualificationReport other = (QualificationReport) obj;
        if (executionQualification != other.executionQualification)
            return false;
        if (nonExecutionQualificationExplanation == null) {
            if (other.nonExecutionQualificationExplanation != null)
                return false;
        }
        else if (!nonExecutionQualificationExplanation.equals(other.nonExecutionQualificationExplanation))
            return false;
        if (qualificationEvaluationException == null) {
            if (other.qualificationEvaluationException != null)
                return false;
        }
        else if (!qualificationEvaluationException.equals(other.qualificationEvaluationException))
            return false;
        if (qualifiedCommand == null) {
            if (other.qualifiedCommand != null)
                return false;
        }
        else if (!qualifiedCommand.equals(other.qualifiedCommand))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "QualificationReport [executionQualification=" + executionQualification + ", qualificationEvaluationException="
                + qualificationEvaluationException + ", nonExecutionQualificationExplanation=" + nonExecutionQualificationExplanation
                + ", qualifiedCommand=" + qualifiedCommand + "]";
    }
    
}
