package com.clcbio.client.thin.model.qualification;

import java.util.HashSet;
import java.util.Set;

import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.algo.parameter.validation.AlgoParameterValidationBeans;

public class QualificationReportAlgo extends QualificationReport{
    private static final long serialVersionUID = -3657621560809786323L;
    private AlgoParameterValidationBeans parameterValidationResult;
    private Set<ClcUrlParameter> missingSourceOrDestination;

    public QualificationReportAlgo() {
        super();
        missingSourceOrDestination = new HashSet<ClcUrlParameter>();
        parameterValidationResult = new AlgoParameterValidationBeans();
    }
    public Set<ClcUrlParameter> getMissingSourceOrDestination() {
        return missingSourceOrDestination;
    }

    public void setMissingSourceOrDestination(Set<ClcUrlParameter> missingSourceOrDestination) {
        this.missingSourceOrDestination = missingSourceOrDestination;
    }

    public AlgoParameterValidationBeans getParameterValidationResult() {
        return parameterValidationResult;
    }

    public void setParameterValidationResult(AlgoParameterValidationBeans parameterValidationResult) {
        this.parameterValidationResult = parameterValidationResult;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((missingSourceOrDestination == null) ? 0 : missingSourceOrDestination.hashCode());
        result = prime * result + ((parameterValidationResult == null) ? 0 : parameterValidationResult.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        QualificationReportAlgo other = (QualificationReportAlgo) obj;
        if (missingSourceOrDestination == null) {
            if (other.missingSourceOrDestination != null)
                return false;
        }
        else if (!missingSourceOrDestination.equals(other.missingSourceOrDestination))
            return false;
        if (parameterValidationResult == null) {
            if (other.parameterValidationResult != null)
                return false;
        }
        else if (!parameterValidationResult.equals(other.parameterValidationResult))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "QualificationReportAlgo [parameterValidationResult=" + parameterValidationResult + ", missingSourceOrDestination="
                + missingSourceOrDestination + "]";
    }

}
