package com.clcbio.client.thin.model.qualification;

import java.util.HashMap;
import java.util.Map;

import com.clcbio.client.thin.model.CommonBeanSerialization;

public class QualificationReportWorkflow extends QualificationReportMaster implements CommonBeanSerialization {
    private static final long serialVersionUID = -4137058659799200320L;
    private WorkflowRoleCommons workflowParameterCommons;
    private Map<String, WorkflowReportCommons> workflowBeanIdCommonsMap;
    
    public QualificationReportWorkflow() {
        super();
        workflowParameterCommons = new WorkflowRoleCommons();
        workflowBeanIdCommonsMap = new HashMap<String, WorkflowReportCommons>();
    }
    
    public Map<String, WorkflowReportCommons> getWorkflowBeanIdCommonsMap() {
        return workflowBeanIdCommonsMap;
    }

    public void setWorkflowBeanIdCommonsMap(Map<String, WorkflowReportCommons> workflowBeanIdCommonsMap) {
        this.workflowBeanIdCommonsMap = workflowBeanIdCommonsMap;
    }

    public WorkflowRoleCommons getWorkflowParameterCommons() {
        return workflowParameterCommons;
    }

    public void setWorkflowParameterCommons(WorkflowRoleCommons workflowParameterCommons) {
        this.workflowParameterCommons = workflowParameterCommons;
    }

    @Override
    public String toString() {
        return "QualificationReportWorkflow [workflowParameterCommons=" + workflowParameterCommons + ", workflowBeanIdCommonsMap="
                + workflowBeanIdCommonsMap + "]";
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((workflowBeanIdCommonsMap == null) ? 0 : workflowBeanIdCommonsMap.hashCode());
        result = prime * result + ((workflowParameterCommons == null) ? 0 : workflowParameterCommons.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        QualificationReportWorkflow other = (QualificationReportWorkflow) obj;
        if (workflowBeanIdCommonsMap == null) {
            if (other.workflowBeanIdCommonsMap != null)
                return false;
        }
        else if (!workflowBeanIdCommonsMap.equals(other.workflowBeanIdCommonsMap))
            return false;
        if (workflowParameterCommons == null) {
            if (other.workflowParameterCommons != null)
                return false;
        }
        else if (!workflowParameterCommons.equals(other.workflowParameterCommons))
            return false;
        return true;
    }
    
}
