package com.clcbio.client.thin.model.qualification;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.command.ServerCommandReference;

public class ServerCommandIdentifier implements CommonBeanSerialization{
    private static final long serialVersionUID = -1351174710558695875L;
    public ServerCommandIdentifier() {
        super();
    }
    
    public ServerCommandIdentifier(String id, String name, double version) {
        super();
        this.id = id;
        this.name = name;
        this.version = version;
    }
    public ServerCommandIdentifier(ServerCommandReference cmdRef) {
        this(cmdRef.getId(), cmdRef.getName(), cmdRef.getVersion());
    }
    public String id;
    public String name;
    public double version;
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + Double.valueOf(version).hashCode();
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ServerCommandIdentifier other = (ServerCommandIdentifier) obj;
        if (id == null) {
            if (other.id != null)
                return false;
        }
        else if (!id.equals(other.id))
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        }
        else if (!name.equals(other.name))
            return false;
        if (!Double.valueOf(version).equals(Double.valueOf(other.version)))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "ServerCommandIdentifier [id=" + id + ", name=" + name + ", version=" + version + "]";
    }
    
}
