package com.clcbio.client.thin.model.qualification;

import com.clcbio.api.clc.workflows.bean.WorkflowRole;
import com.clcbio.client.thin.model.CommonBeanSerialization;

public class WorkflowRoleCommons implements CommonBeanSerialization {
    private static final long serialVersionUID = 5893005727498822714L;
    private WorkflowRole lowestCommonDenominatorMissingParameters;
    private WorkflowRole lowestCommonDenominatorInvalidParameters;
    private WorkflowRole lowestCommonDenominatorInconsistentParameters;
    private WorkflowRole highestCommonDenominatorParameters;
    
    public WorkflowRoleCommons() {
        super();
        lowestCommonDenominatorMissingParameters = WorkflowRole.NONE;
        lowestCommonDenominatorInvalidParameters = WorkflowRole.NONE;
        lowestCommonDenominatorInconsistentParameters = WorkflowRole.NONE;
        highestCommonDenominatorParameters = WorkflowRole.CREATOR;
    }
    
    public WorkflowRole getLowestCommonDenominatorMissingParameters() {
        return lowestCommonDenominatorMissingParameters;
    }
    
    public void setLowestCommonDenominatorMissingParameters(WorkflowRole lowestCommonDenominatorMissingParameters) {
        this.lowestCommonDenominatorMissingParameters = lowestCommonDenominatorMissingParameters;
    }
    
    public WorkflowRole getLowestCommonDenominatorInvalidParameters() {
        return lowestCommonDenominatorInvalidParameters;
    }
    
    public void setLowestCommonDenominatorInvalidParameters(WorkflowRole lowestCommonDenominatorInvalidParameters) {
        this.lowestCommonDenominatorInvalidParameters = lowestCommonDenominatorInvalidParameters;
    }
    
    public WorkflowRole getHighestCommonDenominatorParameters() {
        return highestCommonDenominatorParameters;
    }
    
    public void setHighestCommonDenominatorParameters(WorkflowRole highestCommonDenominatorParameters) {
        this.highestCommonDenominatorParameters = highestCommonDenominatorParameters;
    }
    
    public WorkflowRole getLowestCommonDenominatorInconsistentParameters() {
        return lowestCommonDenominatorInconsistentParameters;
    }

    public void setLowestCommonDenominatorInconsistentParameters(WorkflowRole lowestCommonDenominatorInconsistentParameters) {
        this.lowestCommonDenominatorInconsistentParameters = lowestCommonDenominatorInconsistentParameters;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((highestCommonDenominatorParameters == null) ? 0 : highestCommonDenominatorParameters.hashCode());
        result = prime
                * result
                + ((lowestCommonDenominatorInconsistentParameters == null) ? 0 : lowestCommonDenominatorInconsistentParameters
                        .hashCode());
        result = prime * result
                + ((lowestCommonDenominatorInvalidParameters == null) ? 0 : lowestCommonDenominatorInvalidParameters.hashCode());
        result = prime * result
                + ((lowestCommonDenominatorMissingParameters == null) ? 0 : lowestCommonDenominatorMissingParameters.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        WorkflowRoleCommons other = (WorkflowRoleCommons) obj;
        if (highestCommonDenominatorParameters != other.highestCommonDenominatorParameters)
            return false;
        if (lowestCommonDenominatorInconsistentParameters != other.lowestCommonDenominatorInconsistentParameters)
            return false;
        if (lowestCommonDenominatorInvalidParameters != other.lowestCommonDenominatorInvalidParameters)
            return false;
        if (lowestCommonDenominatorMissingParameters != other.lowestCommonDenominatorMissingParameters)
            return false;
        return true;
    }
    
    @Override
    public String toString() {
        return "WorkflowRoleCommons [lowestCommonDenominatorMissingParameters=" + lowestCommonDenominatorMissingParameters
                + ", lowestCommonDenominatorInvalidParameters=" + lowestCommonDenominatorInvalidParameters
                + ", lowestCommonDenominatorInconsistentParameters=" + lowestCommonDenominatorInconsistentParameters
                + ", highestCommonDenominatorParameters=" + highestCommonDenominatorParameters + "]";
    }
    
}
