package com.clcbio.client.thin.model.safefile;

import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;

public class SafeFileLocation implements CommonBeanSerialization {

    private static final long serialVersionUID = -8443299805470826058L;
    private boolean isDirectory;
    private String itemName;
    private String pathname;
    private boolean permissionRead;
    private boolean permissionWrite;
    private ClcUrlParameter clcUrlParameter; 
    private String serverIconRelativePath;

    public SafeFileLocation() {
        super();
    }

    public ClcUrlParameter getClcUrlParameter() {
        return clcUrlParameter;
    }

    public void setClcUrlParameter(ClcUrlParameter clcUrlParameter) {
        this.clcUrlParameter = clcUrlParameter;
    }

    public boolean isDirectory() {
        return isDirectory;
    }

    public void setDirectory(boolean isDirectory) {
        this.isDirectory = isDirectory;
    }

    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public String getPathname() {
        return pathname;
    }

    public void setPathname(String pathname) {
        this.pathname = pathname;
    }

    public boolean isPermissionRead() {
        return permissionRead;
    }

    public void setPermissionRead(boolean permissionRead) {
        this.permissionRead = permissionRead;
    }

    public boolean isPermissionWrite() {
        return permissionWrite;
    }

    public void setPermissionWrite(boolean permissionWrite) {
        this.permissionWrite = permissionWrite;
    }

    public String getServerIconRelativePath() {
        return serverIconRelativePath;
    }

    public void setServerIconRelativePath(String serverIconRelativePath) {
        this.serverIconRelativePath = serverIconRelativePath;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((clcUrlParameter == null) ? 0 : clcUrlParameter.hashCode());
        result = prime * result + (isDirectory ? 1231 : 1237);
        result = prime * result + ((itemName == null) ? 0 : itemName.hashCode());
        result = prime * result + ((pathname == null) ? 0 : pathname.hashCode());
        result = prime * result + (permissionRead ? 1231 : 1237);
        result = prime * result + (permissionWrite ? 1231 : 1237);
        result = prime * result + ((serverIconRelativePath == null) ? 0 : serverIconRelativePath.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        SafeFileLocation other = (SafeFileLocation) obj;
        if (clcUrlParameter == null) {
            if (other.clcUrlParameter != null)
                return false;
        }
        else if (!clcUrlParameter.equals(other.clcUrlParameter))
            return false;
        if (isDirectory != other.isDirectory)
            return false;
        if (itemName == null) {
            if (other.itemName != null)
                return false;
        }
        else if (!itemName.equals(other.itemName))
            return false;
        if (pathname == null) {
            if (other.pathname != null)
                return false;
        }
        else if (!pathname.equals(other.pathname))
            return false;
        if (permissionRead != other.permissionRead)
            return false;
        if (permissionWrite != other.permissionWrite)
            return false;
        if (serverIconRelativePath == null) {
            if (other.serverIconRelativePath != null)
                return false;
        }
        else if (!serverIconRelativePath.equals(other.serverIconRelativePath))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "SafeFileLocation [isDirectory=" + isDirectory + ", itemName=" + itemName + ", pathname=" + pathname
                + ", permissionRead=" + permissionRead + ", permissionWrite=" + permissionWrite + ", clcUrlParameter="
                + clcUrlParameter + ", serverIconRelativePath=" + serverIconRelativePath + "]";
    }
    
}
