package com.clcbio.client.thin.model.serialization;

import com.clcbio.client.thin.model.CommonBeanSerialization;

/**
 * A serialized version of a Java Bean, 
 * represented as a JSON string.
 *
 */
public class SerializedBeanJSON extends SerializedBeanXML implements CommonBeanSerialization{
    private static final long serialVersionUID = -3961447243876823831L;
    private String jasonSchema;
    private String parameterClassName;
    
    public SerializedBeanJSON() {
        super();
    }
    public SerializedBeanJSON(SerializedBeanJSON parameterJavaBean) {
        super(parameterJavaBean);
        setJasonSchema(parameterJavaBean.getJasonSchema());
        setParameterClassName(getParameterClassName());
    }
    public String getJasonSchema() {
        return jasonSchema;
    }
    public void setJasonSchema(String jasonSchema) {
        this.jasonSchema = jasonSchema;
    }
    public String getParameterClassName() {
        return parameterClassName;
    }
    public void setParameterClassName(String parameterClassName) {
        this.parameterClassName = parameterClassName;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((jasonSchema == null) ? 0 : jasonSchema.hashCode());
        result = prime * result + ((parameterClassName == null) ? 0 : parameterClassName.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        SerializedBeanJSON other = (SerializedBeanJSON) obj;
        if (jasonSchema == null) {
            if (other.jasonSchema != null)
                return false;
        }
        else if (!jasonSchema.equals(other.jasonSchema))
            return false;
        if (parameterClassName == null) {
            if (other.parameterClassName != null)
                return false;
        }
        else if (!parameterClassName.equals(other.parameterClassName))
            return false;
        return true;
    }
    @Override
    public SerializedBeanJSON clone4log() {
        return new SerializedBeanJSON(this);
    }
    @Override
    public String toString() {
        return "TransportParameterJSON [jasonSchema=" + jasonSchema + ", parameterClassName=" + parameterClassName
                + ", stringValue=" + getStringValue() + "]";
    }
    
}
