package com.clcbio.client.thin.model.serialization;

import com.clcbio.client.thin.model.CommonBeanSerialization;

/**
 * A serialized version of a Java Bean,
 * represented as an XML string
 * using the java.beans.XMLDecoder
 *
 */
public class SerializedBeanXML implements CommonBeanSerialization {
    private static final long serialVersionUID = -2672515193292153566L;
    private String stringValue;
    
    public SerializedBeanXML() {
        super();
    }
    public SerializedBeanXML(SerializedBeanXML parameterJavaBean) {
        super();
        setStringValue(parameterJavaBean.getStringValue());
    }
    public String getStringValue() {
        return stringValue;
    }
    public void setStringValue(String stringValue) {
        this.stringValue = stringValue;
    }
    
    public SerializedBeanXML clone4log() {
        return new SerializedBeanXML(this);
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((stringValue == null) ? 0 : stringValue.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        SerializedBeanXML other = (SerializedBeanXML) obj;
        if (stringValue == null) {
            if (other.stringValue != null)
                return false;
        }
        else if (!stringValue.equals(other.stringValue))
            return false;
        return true;
    }
    @Override
    public String toString() {
        return "TransportParameterJavaBean [stringValue=" + stringValue + "]";
    }
    
}
