package com.clcbio.client.thin.model.viewer;

import com.clcbio.client.thin.model.CLCObjectReference;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.editor.elementinfo.ElementInfoList;
import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * @author jschultz A Thin representation of a ClcObject with selected values
 *         from the actual underlying object in the Model
 */
public class ClcObjectThin implements IsSerializable {

    public static final String OBJECT_TYPE_FILE_OBJECT = "FileOject";
    public static final String OBJECT_TYPE_FOLDER_OBJECT = "FolderObject";
    public static final String OBJECT_TYPE_UNKNOWN_CLC_OBJECT = "ObjectTypeUnknownClcObject";

    private HistoryEntryThin[] historyEntryThin;
    private String sequenceAsGBString;
    private ElementInfoList elementInfo;
    private CLCObjectReference objectReference;
    private String htmlDescription;
    private String objectType;
    private ClcUrlParameter clcUrlParameter;

    public String getObjectType() {
        return objectType;
    }

    public void setObjectType(String objectType) {
        this.objectType = objectType;
    }

    public String getHtmlDescription() {
        return htmlDescription;
    }

    public void setHtmlDescription(String htmlDescription) {
        this.htmlDescription = htmlDescription;
    }

    public CLCObjectReference getObjectReference() {
        return objectReference;
    }

    public void setObjectReference(CLCObjectReference objectReference) {
        this.objectReference = objectReference;
    }

    public String getSequenceAsGBString() {
        return sequenceAsGBString;
    }

    public void setSequenceAsGBString(String sequenceAsGBString) {
        this.sequenceAsGBString = sequenceAsGBString;
    }

    public HistoryEntryThin[] getHistoryEntryThin() {
        return historyEntryThin;
    }

    public void setHistoryEntryThin(HistoryEntryThin[] historyEntryThin) {
        this.historyEntryThin = historyEntryThin;
    }

    /**
     * @return the elementInfo
     */
    public ElementInfoList getElementInfo() {
        return elementInfo;
    }

    /**
     * @param elementInfo
     *            the elementInfo to set
     */
    public void setElementInfo(ElementInfoList elementInfo) {
        this.elementInfo = elementInfo;
    }

    public ClcUrlParameter getClcUrlParameter() {
        return clcUrlParameter;
    }

    public void setClcUrlParameter(ClcUrlParameter clcUrlParameter) {
        this.clcUrlParameter = clcUrlParameter;
    }

}
