package com.clcbio.server.model;


import com.clcbio.client.thin.model.CLCObjectReference;
import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.ServerInformation;
import com.clcbio.client.thin.model.admin.ThinPluginDescripterBinaryIcon;
import com.clcbio.client.thin.model.admin.configuration.subsystem.authentication.AuthenticationConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.cluster.SlaveNodeManagerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.directcommand.DirectCommandConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.grid.GridConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.permission.ServerApiPermissionConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.safefiles.SafeFileDirectories;
import com.clcbio.client.thin.model.admin.configuration.subsystem.templatecommand.TemplateCommandManagerConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.users.UserConfiguration;
import com.clcbio.client.thin.model.admin.configuration.subsystem.workflow.WorkflowConfiguration;
import com.clcbio.client.thin.model.admin.configuration.system.ServerMainConfiguration;
import com.clcbio.client.thin.model.clcurl.ClcUrlParameter;
import com.clcbio.client.thin.model.command.algo.ServerCommandAlgoOutput;
import com.clcbio.client.thin.model.command.algo.ServerCommandAlgoParameters;
import com.clcbio.client.thin.model.command.algo.ServerCommandAlgoReference;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeBoolean;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeByte;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrl;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrlFile;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeClcUrlObject;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeDouble;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeInteger;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeLong;
import com.clcbio.client.thin.model.command.algo.parameter.type.ValueTypeString;
import com.clcbio.client.thin.model.command.batch.ServerBatchCommandParameters;
import com.clcbio.client.thin.model.command.clexe.CommandLineExecuterOutput;
import com.clcbio.client.thin.model.command.clexe.CommandLineExecuterParameters;
import com.clcbio.client.thin.model.command.clexe.master.CommandLineExecuterMasterOutput;
import com.clcbio.client.thin.model.command.clexe.master.CommandLineExecuterMasterParameters;
import com.clcbio.client.thin.model.command.clexe.master.CommandLineExecuterMasterReference;
import com.clcbio.client.thin.model.command.clexe.types.TypeBinaryObject;
import com.clcbio.client.thin.model.command.clexe.types.TypeBoolean;
import com.clcbio.client.thin.model.command.clexe.types.TypeBooleanCompound;
import com.clcbio.client.thin.model.command.clexe.types.TypeCommandOutput;
import com.clcbio.client.thin.model.command.clexe.types.TypeContextSubstitute;
import com.clcbio.client.thin.model.command.clexe.types.TypeCsvEnum;
import com.clcbio.client.thin.model.command.clexe.types.TypeDouble;
import com.clcbio.client.thin.model.command.clexe.types.TypeExportCommandOutput;
import com.clcbio.client.thin.model.command.clexe.types.TypeImportCommandInput;
import com.clcbio.client.thin.model.command.clexe.types.TypeInteger;
import com.clcbio.client.thin.model.command.clexe.types.TypeSafeFile;
import com.clcbio.client.thin.model.command.clexe.types.TypeString;
import com.clcbio.client.thin.model.command.direct.DirectCommandOutput;
import com.clcbio.client.thin.model.command.direct.DirectCommandParameters;
import com.clcbio.client.thin.model.command.direct.DirectCommandReference;
import com.clcbio.client.thin.model.command.exporter.ServerExportCommandReference;
import com.clcbio.client.thin.model.command.exporter.ServerExporterOutput;
import com.clcbio.client.thin.model.command.exporter.ServerExporterParameters;
import com.clcbio.client.thin.model.command.grid.GridExecuterCommandReference;
import com.clcbio.client.thin.model.command.grid.GridExecuterParameters;
import com.clcbio.client.thin.model.command.importer.ServerImportCommandReference;
import com.clcbio.client.thin.model.command.importer.ServerImporterOutput;
import com.clcbio.client.thin.model.command.importer.ServerImporterParameters;
import com.clcbio.client.thin.model.command.maintenance.RemoveTerminatedProcessesCommandReference;
import com.clcbio.client.thin.model.command.maintenance.RemoveTerminatedProcessesOutput;
import com.clcbio.client.thin.model.command.maintenance.RemoveTerminatedProcessesParameters;
import com.clcbio.client.thin.model.command.plugin.ServerPluginManagementCommandReference;
import com.clcbio.client.thin.model.command.plugin.ServerPluginManagementParameters;
import com.clcbio.client.thin.model.command.workflow.WorkflowCommandOutput;
import com.clcbio.client.thin.model.command.workflow.WorkflowCommandParameters;
import com.clcbio.client.thin.model.command.workflow.parameter.WorkflowElementBeanParameterExternal;
import com.clcbio.client.thin.model.command.workflow.parameter.WorkflowElementBeanParameterExternalOrphane;
import com.clcbio.client.thin.model.executionenvironment.ServerCLCExecutionEnvironment;
import com.clcbio.client.thin.model.executionenvironment.ServerGridExecutionEnvironment;
import com.clcbio.client.thin.model.legacy.CLCFileObjectReference;
import com.clcbio.client.thin.model.legacy.CLCObjectReferences;
import com.clcbio.client.thin.model.log.DataBaseType;
import com.clcbio.client.thin.model.persistence.TransportInsertResult;
import com.clcbio.client.thin.model.persistence.TransportPersistenceContainer;
import com.clcbio.client.thin.model.persistence.TransportPersistenceElement;
import com.clcbio.client.thin.model.persistence.TransportPersistenceFile;
import com.clcbio.client.thin.model.persistence.TransportPersistenceStructure;
import com.clcbio.client.thin.model.persistence.TransportRecycleBin;
import com.clcbio.client.thin.model.qualification.QualificationReportAlgo;
import com.clcbio.client.thin.model.qualification.QualificationReportMaster;
import com.clcbio.client.thin.model.qualification.QualificationReportWorkflow;
import com.clcbio.client.thin.model.safefile.SafeFileLocation;
import com.clcbio.client.thin.model.safefile.SafeFileLocations;
import com.clcbio.client.thin.model.serialization.SerializedBeanJSON;
import com.clcbio.server.model.plugin.ThinPluginDescripterAttachment;

/**
 * This is a collection for the JAX-B "@XmlSeeAlso" tag not necessary equal to
 * the GwtWhitelist in our GWT interface; public since JAX-B has other rules for
 * serialization and object hierarchy traversal. Furthermore we might also have
 * different opinions about which object should go where.
 */
public class SoapWhitelist implements CommonBeanSerialization {
    private static final long serialVersionUID = -6864178384289351070L;
    public TransportInsertResult a;
    public TransportPersistenceStructure b;
    public TransportPersistenceElement c;
    public TransportPersistenceContainer d;
    public TransportRecycleBin e;
    public TransportPersistenceFile f;
    public ServerCommandAlgoParameters g;
    public ServerCommandAlgoOutput h;
    public CLCObjectReferences i;
    public CLCObjectReference j;
    public ServerImportCommandReference k;
    public ServerImporterParameters l;
    public ServerImporterOutput m;
    public ServerExportCommandReference n;
    public ServerExporterParameters o;
    public ServerExporterOutput p;
    public RemoveTerminatedProcessesCommandReference q;
    public RemoveTerminatedProcessesOutput r;
    public RemoveTerminatedProcessesParameters s;
    public SOAPBinaryData t;
    public DataBaseType u;
    public SlaveNodeManagerConfiguration v;
    public ServerMainConfiguration w;
    public ServerPluginManagementCommandReference x;
    public ServerPluginManagementParameters y;
    public TemplateCommandManagerConfiguration z;
    public CommandLineExecuterParameters a1;
    public CommandLineExecuterOutput b1;
    public TypeString c1;
    public TypeExportCommandOutput d1;
    public TypeImportCommandInput e1;
    public TypeCommandOutput f1;
    public TypeBoolean g1;
    public TypeBinaryObject h1;
    public CommandLineExecuterMasterParameters i1;
    public TypeCsvEnum j1;
    public TypeBooleanCompound k1;
    public TypeDouble l1;
    public AuthenticationConfiguration m1;
    public UserConfiguration n1;
    public CommandLineExecuterMasterOutput o1;
    public CLCFileObjectReference p1;
    public ServerInformation q1;
    public CommandLineExecuterMasterReference r1;
    public SafeFileDirectories s1;
    public SafeFileLocation t1;
    public SafeFileLocations u1;
    public GridExecuterCommandReference v1;
    public GridExecuterParameters w1;
    public GridConfiguration x1;
    public ServerBatchCommandParameters y1;
    public ClcUrlParameter z1;
    public ClcUrlParameterWithAttachment a2;
    public ServerCLCExecutionEnvironment b2;
    public ServerGridExecutionEnvironment c2;
    public ServerApiPermissionConfiguration d2;
    public DirectCommandReference e2;
    public DirectCommandOutput f2;
    public DirectCommandParameters g2;
    public SerializedBeanJSON h2;
    public DirectCommandConfiguration i2;
    public TypeContextSubstitute j2;
    public WorkflowCommandParameters k2;
    public WorkflowConfiguration l2;
    public ServerCommandAlgoReference m2;
    public ThinPluginDescripterBinaryIcon n2;
    public WorkflowElementBeanParameterExternal o2;
    public ThinPluginDescripterAttachment p2;
    public ValueTypeBoolean q2;
    public ValueTypeByte r2;
    public ValueTypeClcUrl s2;
    public ValueTypeClcUrlFile t2;
    public ValueTypeClcUrlObject u2;
    public ValueTypeDouble v2;
    public ValueTypeInteger w2;
    public ValueTypeLong x2;
    public ValueTypeString y2;
    public WorkflowElementBeanParameterExternalOrphane z2;
    public TypeInteger a3;
    public WorkflowCommandOutput b3;
    public QualificationReportAlgo c3;
    public QualificationReportMaster d3;
    public QualificationReportWorkflow e3;
    public TypeSafeFile f3;
    
}
