package com.clcbio.server.soap;

import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;

import com.clcbio.client.thin.api.CLCServerApiAdmin;
import com.clcbio.client.thin.api.CLCServerApiData;
import com.clcbio.client.thin.api.CLCServerApiPersistenceModel;
import com.clcbio.client.thin.api.CLCServerApiProcess;
import com.clcbio.client.thin.model.CommonBeanSerialization;
import com.clcbio.client.thin.model.GwtWhitelist;
import com.clcbio.client.thin.model.exceptions.ServiceException;
import com.clcbio.server.model.SoapWhitelist;

/***                                                                                                
* <pre>                                                                                             
*                                The CLC Server API                                                 
*                                                                                                   
*                                                                                                   
*                                                                                                   
*                                                                                                   
*      +------------------------------+                                                             
*      |      CLCServerApiAdmin       |   ^                ^                                        
*      +------------------------------+   |                |                                        
*      +------------------------------+   |                |                                        
*      |      CLCServerApiData        |   |                |                                        
*      +------------------------------+   |SOAP exposed    |GWT exposed                             
*      +------------------------------+   |                |                                        
*      |      CLCServerApiProcess     |   |                V                                        
*      +------------------------------+   |                                                         
*      +------------------------------+   |                                                         
*      | CLCServerApiPersistenceModel |   V                                                         
*      +------------------------------+                                                             
*                                                                                                   
*                                                                                                   
*                                                                                                   
*                                                                                                   
*                                                                                                   
*      +------------------------------+      The sum of the specific                                
*      |      CLCServerApi            |      Interfaces above.                                      
*      +------------------------------+      Defining the SOAP API.                                 
*                                            This is the SOAP client                                
*                                            interface.                                             
*                                                                                                   
*                                                                                                   
*      +------------------------------+      The implementation of                                  
*      | CLCScienceServer             |      ICLCScienceServer.                                     
*      +------------------------------+      This is the SOAP server                                
*                                            implementation.                                        
*                                                                                                   
                                                                                                    
*                                                                                                   
*</pre>                                                                                             
*                                                                                                   
*/                                                                                                  
@WebService(targetNamespace="http://soap.clcbio.com/")
@XmlSeeAlso({ SoapWhitelist.class })
public interface CLCServerApi extends CLCServerApiProcess, CLCServerApiAdmin, CLCServerApiData, CLCServerApiPersistenceModel {
    public static long SERVER_API_VERSION = 125;
    /**
     * State the methods we wish not to publish as a
     * webservice in the Service Endpoint Interface. Used when this server is acting
     * as a client towards other servers. The webmethods excluded must be excluded
     * in the CLCScienceServer implementation as well since this is the one acting
     * as the other server
     */
    
    @WebMethod(exclude = true)
    public CommonBeanSerialization javaBeanXMLDecode(String sessionID, String serialisedXmlBean) throws ServiceException;
    
    @WebMethod(exclude = true)
    public void types(GwtWhitelist gwtWhitelist)
            throws ServiceException;
}
